//csc.exe /target:winexe /optimize videos-app.cs
//.NET 4.8
using System;
using System.ComponentModel;
using System.Windows.Forms;
using System.Drawing;
using System.IO;
using System.Text;
using System.Globalization;
using System.Collections.Generic;
using System.Net;
//using System.Net.Security;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Threading;

namespace AwemerApp {
	[DataContract]
	public class UrlData {
		[DataMember(Name = "url_list")]
		public string[] UrlList;
	}
	[DataContract]
	public class VideoData {
		[DataMember(Name = "play_addr")]
		public UrlData PlayAddr;
		//[DataMember(Name = "play_addr_264")]
		//public UrlData PlayAddr264;
		[DataMember(Name = "play_addr_265")]
		public UrlData PlayAddr265;
		[DataMember(Name = "play_addr_bytevc1")]
		public UrlData PlayAddrBytevc1;
	}
	[DataContract]
	public class AwemeDetailData {
		[DataMember(Name = "aweme_id")]
		public string AwemeId;
		[DataMember(Name = "create_time")]
		public long CreateTime;
		[DataMember(Name = "desc")]
		public string Desc;
		[DataMember(Name = "video")]
		public VideoData Video;
	}
	[DataContract]
	public class UserVideosData {
		//[DataMember(Name = "status_code")]
		//public long StatusCode;
		[DataMember(Name = "has_more")]
		public int HasMore;
		[DataMember(Name = "max_cursor")]
		public long MaxCursor;
		[DataMember(Name = "aweme_list")]
		public AwemeDetailData[] AwemeList;
	}
	[DataContract]
	public class MusicVideosData {
		//[DataMember(Name = "status_code")]
		//public long StatusCode;
		[DataMember(Name = "has_more")]
		public int HasMore;
		[DataMember(Name = "cursor")]
		public long Cursor;
		[DataMember(Name = "aweme_list")]
		public AwemeDetailData[] AwemeList;
	}
	[DataContract]
	public class ChallengeVideosData {
		//[DataMember(Name = "status_code")]
		//public long StatusCode;
		[DataMember(Name = "has_more")]
		public int HasMore;
		[DataMember(Name = "cursor")]
		public long Cursor;
		[DataMember(Name = "aweme_list")]
		public AwemeDetailData[] AwemeList;
	}
	[DataContract]
	public class VideosData {
		//[DataMember(Name = "status_code")]
		//public long StatusCode;
		[DataMember(Name = "aweme_details")]
		public AwemeDetailData[] AwemeDetails;
	}
	/*[DataContract]
	public class UserStatsData {
		[DataMember(Name = "diggCount")]
		public long DiggCount;
		[DataMember(Name = "followerCount")]
		public long FollowerCount;
		[DataMember(Name = "followingCount")]
		public long FollowingCount;
		//[DataMember(Name = "heart")]
		//public long Heart;
		[DataMember(Name = "heartCount")]
		public long HeartCount;
		[DataMember(Name = "videoCount")]
		public long VideoCount;
	}
	[DataContract]
	public class LinkData {
		[DataMember(Name = "link")]
		public string Link;
	}*/
	[DataContract]
	public class UserData_ {
		[DataMember(Name = "id")]
		public string Id;
		[DataMember(Name = "uniqueId")]
		public string UniqueId;
		//[DataMember(Name = "secUid")]
		//public string SecUid;
		//[DataMember(Name = "nickname")]
		//public string Nickname;
		//[DataMember(Name = "openFavorite")]
		//public bool OpenFavorite;
		//[DataMember(Name = "secret")]
		//public bool Secret;
		//[DataMember(Name = "verified")]
		//public bool Verified;
		//[DataMember(Name = "avatarLarger")]
		//public string AvatarLarger;
		//[DataMember(Name = "signature")]
		//public string Signature;
		//[DataMember(Name = "bioLink")]
		//public LinkData BioLink;
	}
	[DataContract]
	public class UserInfoData_ {
		//[DataMember(Name = "stats")]
		//public UserStatsData Stats;
		[DataMember(Name = "user")]
		public UserData_ User;
	}
	/*[DataContract]
	public class UserNode {
		[DataMember(Name = "statusCode", IsRequired = true)]
		public long StatusCode;
		[DataMember(Name = "userInfo")]
		public UserInfoData_ UserInfo;
	}*/
	[DataContract]
	public class UserSearch {
		[DataMember(Name = "statusCode", IsRequired = true)]
		public long StatusCode;
		//[DataMember(Name = "offset")]
		//public long Offset;
		[DataMember(Name = "userInfoList")]
		public UserInfoData_[] UserInfoList;
	}
	/*[DataContract]
	public class ChallengeStatsData {
		[DataMember(Name = "videoCount")]
		public long VideoCount;
		[DataMember(Name = "viewCount")]
		public long ViewCount;
	}*/
	[DataContract]
	public class ChallengeData_ {
		[DataMember(Name = "id")]
		public string Id;
		[DataMember(Name = "title")]
		public string Title;
		//[DataMember(Name = "profileLarger")]
		//public string ProfileLarger;
		//[DataMember(Name = "desc")]
		//public string Desc;
	}
	[DataContract]
	public class ChallengeInfoData_ {
		//[DataMember(Name = "stats")]
		//public ChallengeStatsData Stats;
		[DataMember(Name = "challenge")]
		public ChallengeData_ Challenge;
	}
	/*[DataContract]
	public class ChallengeNode {
		[DataMember(Name = "statusCode", IsRequired = true)]
		public long StatusCode;
		[DataMember(Name = "challengeInfo")]
		public ChallengeInfoData_ ChallengeInfo;
	}*/
	[DataContract]
	public class ChallengeSearch {
		[DataMember(Name = "statusCode", IsRequired = true)]
		public long StatusCode;
		//[DataMember(Name = "offset")]
		//public long Offset;
		[DataMember(Name = "challengeInfoList")]
		public ChallengeInfoData_[] ChallengeInfoList;
	}
	[DataContract]
	public class MainData {
		[DataMember(Name = "hls")]
		public string Hls;
		[DataMember(Name = "flv")]
		public string Flv;
	}
	[DataContract]
	public class OriginData {
		[DataMember(Name = "main")]
		public MainData Main;
	}
	[DataContract]
	public class DataData {
		[DataMember(Name = "origin")]
		public OriginData Origin;
	}
	[DataContract]
	public class StreamData {
		[DataMember(Name = "data")]
		public DataData Data;
	}
	[DataContract]
	public class PullDataData {
		[DataMember(Name = "stream_data")]
		public string StreamData;
	}
	[DataContract]
	public class LiveCoreSdkDataData {
		[DataMember(Name = "pull_data")]
		public PullDataData PullData;
	}
	[DataContract]
	public class StreamUrlData {
		[DataMember(Name = "live_core_sdk_data")]
		public LiveCoreSdkDataData LiveCoreSdkData;
	}
	[DataContract]
	public class RoomData {
		[DataMember(Name = "stream_url")]
		public StreamUrlData StreamUrl;
	}
	[DataContract]
	public class UserData {
		[DataMember(Name = "uid")]
		public string Uid;
		[DataMember(Name = "unique_id")]
		public string UniqueId;
		[DataMember(Name = "sec_uid")]
		public string SecUid;
		[DataMember(Name = "nickname")]
		public string Nickname;
		[DataMember(Name = "aweme_count")]
		public long AwemeCount;
		[DataMember(Name = "favoriting_count")]
		public long FavoritingCount;
		[DataMember(Name = "total_favorited")]
		public long TotalFavorited;
		[DataMember(Name = "following_count")]
		public long FollowingCount;
		[DataMember(Name = "follower_count")]
		public long FollowerCount;
		[DataMember(Name = "secret")]
		public int Secret;
		[DataMember(Name = "avatar_larger")]
		public UrlData AvatarLarger;
		[DataMember(Name = "video_icon")]
		public UrlData VideoIcon;
		[DataMember(Name = "room_id")]
		public long RoomId;
		[DataMember(Name = "room_data")]
		public string RoomData;
		[DataMember(Name = "ins_id")]
		public string InsId;
		[DataMember(Name = "youtube_channel_id")]
		public string YoutubeChannelId;
		[DataMember(Name = "signature")]
		public string Signature;
		[DataMember(Name = "bio_url")]
		public string BioUrl;
	}
	[DataContract]
	public class UserInfoData {
		[DataMember(Name = "user")]
		public UserData User;
	}
	[DataContract]
	public class MusicData {
		[DataMember(Name = "mid")]
		public string Mid;
		[DataMember(Name = "title")]
		public string Title;
		[DataMember(Name = "owner_id")]
		public string OwnerId;
		[DataMember(Name = "owner_handle")]
		public string OwnerHandle;
		[DataMember(Name = "sec_uid")]
		public string SecUid;
		[DataMember(Name = "author")]
		public string Author;
		[DataMember(Name = "user_count")]
		public long UserCount;
		[DataMember(Name = "duration")]
		public int Duration;
		[DataMember(Name = "cover_hd")]
		public UrlData CoverHd;
		[DataMember(Name = "play_url")]
		public UrlData PlayUrl;
	}
	[DataContract]
	public class MusicInfoData {
		[DataMember(Name = "music_info")]
		public MusicData MusicInfo;
	}
	[DataContract]
	public class ChallengeData {
		[DataMember(Name = "cid")]
		public string Cid;
		[DataMember(Name = "cha_name")]
		public string ChaName;
		[DataMember(Name = "user_count")]
		public long UserCount;
		[DataMember(Name = "view_count")]
		public long ViewCount;
		[DataMember(Name = "hashtag_profile")]
		public string HashtagProfile;
		[DataMember(Name = "desc")]
		public string Desc;
	}
	[DataContract]
	public class ChallengeInfoData {
		[DataMember(Name = "ch_info")]
		public ChallengeData ChInfo;
	}
	[DataContract]
	public class AwemeStatisticsData {
		[DataMember(Name = "play_count")]
		public long PlayCount;
		[DataMember(Name = "digg_count")]
		public long DiggCount;
		[DataMember(Name = "comment_count")]
		public long CommentCount;
		[DataMember(Name = "share_count")]
		public long ShareCount;
		[DataMember(Name = "download_count")]
		public long DownloadCount;
	}
	[DataContract]
	public class VideoData_ {
		[DataMember(Name = "origin_cover")]
		public UrlData OriginCover;
		[DataMember(Name = "dynamic_cover")]
		public UrlData DynamicCover;
		[DataMember(Name = "play_addr")]
		public UrlData PlayAddr;
		//[DataMember(Name = "play_addr_264")]
		//public UrlData PlayAddr264;
		[DataMember(Name = "play_addr_265")]
		public UrlData PlayAddr265;
		[DataMember(Name = "play_addr_bytevc1")]
		public UrlData PlayAddrBytevc1;
	}
	[DataContract]
	public class AwemeDetailData_ {
		[DataMember(Name = "aweme_id")]
		public string AwemeId;
		[DataMember(Name = "create_time")]
		public long CreateTime;
		[DataMember(Name = "statistics")]
		public AwemeStatisticsData Statistics;
		[DataMember(Name = "desc")]
		public string Desc;
		[DataMember(Name = "video")]
		public VideoData_ Video;
		[DataMember(Name = "music")]
		public MusicData Music;
		[DataMember(Name = "author")]
		public UserData Author;
	}
	[DataContract]
	public class VideoInfoData {
		[DataMember(Name = "aweme_detail")]
		public AwemeDetailData_ AwemeDetail;
	}
	public struct Aweme {
		public string Id;
		public long Date;
		public string Description;
		public string Url;
		public bool AddDate;
		public bool AddDescription;
	}
	public struct Download {
		public string Id;
		public long Limit;
		public bool IsMax;
		public long Cursor;
	}
	/*public class UnexpectedException: Exception {
		public UnexpectedException() {}
		public UnexpectedException(string message): base(message) {}
		public UnexpectedException(string message, Exception inner): base(message, inner) {}
	}*/
	public class AwemeWebClient: WebClient {
		protected override WebResponse GetWebResponse(WebRequest request) {
			(request as HttpWebRequest).AllowAutoRedirect = true;
			HttpWebResponse r = base.GetWebResponse(request) as HttpWebResponse;
			if (r.ContentLength == 0) {
				throw new Exception("Response body is empty.");
			}
			return r;
		}
		/*public bool DownloadNonEmptyFile(Uri uri, string filename, byte[] buffer) {
			int i;
			byte[] b;
			Stream s;
			FileStream f;
			using (s = OpenRead(uri)) {
				if ((i = s.ReadByte()) == -1) {
					return false;
				}
				b = buffer != null ? buffer : new byte[1024];
				using (f = new FileStream(filename, FileMode.Create)) {
					f.WriteByte((byte)i);
					while ((i = s.Read(b, 0, b.Length)) > 0) {
						f.Write(b, 0, i);
					}
					f.Flush();
				}
			}
			return true;
		}
		public bool DownloadNonEmptyFile(string uri, string filename, byte[] buffer) {
			return DownloadNonEmptyFile(new Uri(uri), filename, buffer);
		}*/
	}
	public class MainForm: Form {
		public string Root;
		public string Dir;
		public bool Stop;
		public bool Date;
		public bool Description;
		public bool Quality;
		public bool Hevc;
		public int Device;
		public string[,] Devices = new string[,] {
			{"6840334962471175685", "6840335458925397765"},
			{"6840337721254790662", "6840338216047707910"},
			{"6840338200164533766", "6840338715577026309"},
			{"6840338714964674054", "6840339317790639877"},
			{"6840339645260252678", "6840340125466183429"},
			{"6840340139303323141", "6840340629818509061"},
			{"6840340832932578821", "6840341267235505925"},
			{"6625511350049277445", "6840342025746974470"},
			{"6840342262309029381", "6840342731110844166"},
			{"6840342774875719174", "6840343313359439621"},
			{"6840343438564296198", "6840343849450686214"},
			{"6840343811962406406", "6840344404969883397"},
			{"6840346205621339653", "6840346594418132742"},
			{"6840347184661366277", "6840347755685250822"},
			{"6840347832502224389", "6840348361754953477"},
			{"6840348441643140613", "6840348893181134598"},
			{"6840349269573076485", "6840349725176334086"},
			{"6840349761360053766", "6840350277971871493"},
			{"6656311847363708418", "6840351138416641797"},
			{"6832710362678593030", "6840351657282635526"},
			{"6598922056296089093", "6840352409791022853"},
			{"6840352536298948102", "6840353028811409157"},
			{"6840352903107675653", "6840353535470913285"},
			{"6840353495889102342", "6840354043367016197"},
			{"6840354213819401733", "6840354760332756741"},
			{"6840354692200433158", "6840355275271718662"},
			{"6840355122121475590", "6840355754320348933"},
			{"6620959547542521349", "6840356246375335685"},
			{"6702452786442798593", "6840356807903790853"},
			{"6666977815319234049", "6840357206518548230"},
			{"6626849856956712454", "6840357703454394117"},
			{"6649894210089485829", "6840358143043192581"},
			{"6840376504355685894", "6840376843440539398"},
			{"6840377082561447430", "6840377407690688261"},
			{"6840377655038199302", "6840377938056709894"},
			{"6625078848545621509", "6840378503775864582"},
			{"6840378675810190853", "6840379026114512646"},
			{"6840379229281453574", "6840379503329986309"},
			{"6617681194681222658", "6840380047426553605"},
			{"6840380328432862725", "6840380566757590789"},
			{"6840380925751363078", "6840381241076270853"},
			{"6840381372672263685", "6840381660366702342"},
			{"6840381868345525766", "6840382172479145733"},
			{"6840382343040337413", "6840382642992088838"},
			{"6840382891022157318", "6840383173298718469"},
			{"6840383368066385414", "6840383673004918534"},
			{"6840383908283926022", "6840384170293905158"},
			{"6840384366641956357", "6840384640102041350"},
			{"6840384844104549894", "6840385205023311621"},
			{"6840385439472633349", "6840385714204329733"},
			{"6840385932186715654", "6840386241411548934"},
			{"6840386316464637445", "6840386683671185158"},
			{"6840386833165190661", "6840387170454406917"},
			{"6840387324859385350", "6840387658528229125"},
			{"6840387770995213830", "6840388113425811206"},
			{"6840388359279461893", "6840388647155287814"},
			{"6626962021533369861", "6840389227848648453"},
			{"6840389457519396357", "6840389697581008645"},
			{"6840389962187064838", "6840390307339847429"},
			{"6840390542419133957", "6840390854117902085"},
			{"6621641155304031745", "6840391302350800646"},
			{"6665370884931814913", "6840391804890842886"},
			{"6840392104335918597", "6840392397495781126"},
			{"6840393474446968326", "6840393703317538565"}
		};
		//public string DeviceId = "6672757199980234245";
		//public string IId = "6753521729043285766";
		//public string DeviceVersion = GenerateBase62(8);
		//public string Os = GenerateBase62(16);
		//public string Cookie = GenerateCookie();
		//public string Ip = "";
		public int Count;
		public FileStream Logger = null;
		public Graphics Graphics = null;
		public IContainer Components = new Container();
		public ToolTip Tip = new ToolTip();
		public FolderBrowserDialog DirOpener = new FolderBrowserDialog();
		public OpenFileDialog FileOpener = new OpenFileDialog();
		public CheckBox Log = new CheckBox();
		public CheckBox AddDate = new CheckBox();
		public CheckBox AddDescription = new CheckBox();
		public CheckBox ImproveQuality = new CheckBox();
		public CheckBox PreferHevc = new CheckBox();
		public Label DirLabel = new Label();
		public TextBox DirInput = new TextBox();
		public Button OpenDir = new Button();
		public Label TypeLabel = new Label();
		public ComboBox TypeInput = new ComboBox();
		public Label IdLabel = new Label();
		public TextBox IdInput = new TextBox();
		public Button OpenFile = new Button();
		public Label LimitLabel = new Label();
		public TextBox LimitInput = new TextBox();
		public Label CursorLabel = new Label();
		public TextBox CursorInput = new TextBox();
		public Button Info = new Button();
		public Button Download = new Button();
		public TextBox Output = new TextBox();
		public readonly object StopLock = new Object();
		public readonly object OutLock = new Object();
		public readonly object SyncLock = new Object();
		public MainForm(string root, string directory) {
			Root = root;
			Dir = directory;
			SuspendLayout();
			Components.Add(Tip);
			Components.Add(DirOpener);
			Components.Add(FileOpener);
			Graphics = CreateGraphics();
			RandomizeDevices(Devices);
			int t, w = (int)Graphics.MeasureString("directory:", DirLabel.Font).Width + 5;
			DirOpener.RootFolder = Environment.SpecialFolder.Desktop;
			DirOpener.SelectedPath = Root + Path.DirectorySeparatorChar + Dir;
			FileOpener.Title = "Select a file";
			FileOpener.RestoreDirectory = true;
			FileOpener.Filter = "Text file (*.txt)|*.txt|Any file (*.*)|*.*";
			FileOpener.InitialDirectory = Root;
			Log.AutoSize = false;
			Log.Size = new Size((int)Graphics.MeasureString("log", Log.Font).Width + 24, 21);
			Log.Location = new Point(5, t = 5);
			Log.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			Log.Text = "log";
			AddDate.AutoSize = false;
			AddDate.Size = new Size((int)Graphics.MeasureString("add date", AddDate.Font).Width + 24, 21);
			AddDate.Location = new Point(5, t += 5 + 21);
			AddDate.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			AddDate.Text = "add date";
			AddDate.CheckedChanged += AddDateChanged;
			AddDescription.AutoSize = false;
			AddDescription.Size = new Size((int)Graphics.MeasureString("add description", AddDescription.Font).Width + 24, 21);
			AddDescription.Location = new Point(5, t += 5 + 21);
			AddDescription.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			AddDescription.Text = "add description";
			AddDescription.CheckedChanged += AddDescriptionChanged;
			ImproveQuality.AutoSize = false;
			ImproveQuality.Size = new Size((int)Graphics.MeasureString("improve quality", ImproveQuality.Font).Width + 24, 21);
			ImproveQuality.Location = new Point(5, t += 5 + 21);
			ImproveQuality.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			ImproveQuality.Text = "improve quality";
			ImproveQuality.CheckedChanged += ImproveQualityChanged;
			PreferHevc.AutoSize = false;
			PreferHevc.Size = new Size((int)Graphics.MeasureString("prefer HEVC/H.265", PreferHevc.Font).Width + 24, 21);
			PreferHevc.Location = new Point(5, t += 5 + 21);
			PreferHevc.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			PreferHevc.Text = "prefer HEVC/H.265";
			PreferHevc.CheckedChanged += PreferHevcChanged;
			DirLabel.AutoSize = false;
			DirLabel.Size = new Size(w, 21);
			DirLabel.Location = new Point(5, t += 5 + 21);
			DirLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			DirLabel.Text = "directory:";
			DirLabel.TextAlign = ContentAlignment.MiddleLeft;
			DirInput.Size = new Size(210 - 26, 21);
			DirInput.Location = new Point(2 * 5 + w, t);
			DirInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			DirInput.Text = Dir;
			DirInput.Leave += DirLeave;
			OpenDir.Size = new Size(21, 21);
			OpenDir.Location = new Point(2 * 5 + w + 210 - 21, t);
			OpenDir.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right);
			OpenDir.Text = "⯇";
			OpenDir.Click += OpenDirClick;
			TypeLabel.AutoSize = false;
			TypeLabel.Size = new Size(w, 21);
			TypeLabel.Location = new Point(5, t += 5 + 21);
			TypeLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			TypeLabel.Text = "type:";
			TypeLabel.TextAlign = ContentAlignment.MiddleLeft;
			TypeInput.Size = new Size(210, 21);
			TypeInput.Location = new Point(2 * 5 + w, t);
			TypeInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			TypeInput.DropDownStyle = ComboBoxStyle.DropDownList;
			TypeInput.Items.Add("user videos");
			TypeInput.Items.Add("user favorites");
			TypeInput.Items.Add("music videos");
			TypeInput.Items.Add("hashtag videos");
			TypeInput.Items.Add("videos");
			TypeInput.SelectedIndex = 0;
			TypeInput.SelectedIndexChanged += TypeSelectedIndexChanged;
			IdLabel.AutoSize = false;
			IdLabel.Size = new Size(w, 21);
			IdLabel.Location = new Point(5, t += 5 + 21);
			IdLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			IdLabel.Text = "id/name:";
			IdLabel.TextAlign = ContentAlignment.MiddleLeft;
			IdInput.Size = new Size(210, 21);
			IdInput.Location = new Point(2 * 5 + w, t);
			IdInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			OpenFile.Size = new Size(21, 21);
			OpenFile.Location = new Point(2 * 5 + w + 210 - 21, t);
			OpenFile.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right);
			OpenFile.Text = "⯇";
			OpenFile.Visible = false;
			OpenFile.Click += OpenFileClick;
			LimitLabel.AutoSize = false;
			LimitLabel.Size = new Size(w, 21);
			LimitLabel.Location = new Point(5, t += 5 + 21);
			LimitLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			LimitLabel.Text = "date/max:";
			LimitLabel.TextAlign = ContentAlignment.MiddleLeft;
			LimitInput.Size = new Size(210, 21);
			LimitInput.Location = new Point(2 * 5 + w, t);
			LimitInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			CursorLabel.AutoSize = false;
			CursorLabel.Size = new Size(w, 21);
			CursorLabel.Location = new Point(5, t += 5 + 21);
			CursorLabel.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Left);
			CursorLabel.Text = "cursor:";
			CursorLabel.TextAlign = ContentAlignment.MiddleLeft;
			CursorInput.Size = new Size(210, 21);
			CursorInput.Location = new Point(2 * 5 + w, t);
			CursorInput.Text = "0";
			CursorInput.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Left);
			w = 3 * 5 + w + 210;
			Info.Size = new Size(90, 21);
			Info.Location = new Point(w / 2 - 90 - 5, t += 5 + 21);
			Info.Anchor = (AnchorStyles)(AnchorStyles.Top);
			Info.Text = "info";
			Info.Click += InfoClick;
			Download.Size = new Size(90, 21);
			Download.Location = new Point(w / 2 + 5, t);
			Download.Anchor = (AnchorStyles)(AnchorStyles.Top);
			Download.Text = "download";
			Download.Click += DownloadClick;
			Output.Size = new Size(w - 2 * 5, 210);
			Output.Location = new Point(5, t += 5 + 21);
			Output.Anchor = (AnchorStyles)(AnchorStyles.Top | AnchorStyles.Right | AnchorStyles.Bottom | AnchorStyles.Left);
			Output.Multiline = true;
			Output.ReadOnly = true;
			Output.BackColor = Color.FromKnownColor(KnownColor.Window);
			Output.WordWrap = false;
			Output.ScrollBars = ScrollBars.Both;
			Tip.ShowAlways = true;
			Tip.AutoPopDelay = 9000;
			Tip.InitialDelay = 300;
			Tip.ReshowDelay = 300;
			Tip.SetToolTip(DirInput, "directory");
			Tip.SetToolTip(TypeInput, "type");
			Tip.SetToolTip(IdInput, "id/name (id or @name) - id or name of a user");
			Tip.SetToolTip(LimitInput, "date/max (optional - YYYY-MM-DD or integer) - date until which to check videos or max number of videos to check");
			Tip.SetToolTip(CursorInput, "cursor (integer) - unix time in milliseconds");
			Tip.SetToolTip(Output, "output");
			ClientSize = new Size(w, t + 5 + 210);
			Text = "videos";
			ShowIcon = false;
			Controls.Add(Log);
			Controls.Add(AddDate);
			Controls.Add(AddDescription);
			Controls.Add(ImproveQuality);
			Controls.Add(PreferHevc);
			Controls.Add(DirLabel);
			Controls.Add(DirInput);
			Controls.Add(OpenDir);
			Controls.Add(TypeLabel);
			Controls.Add(TypeInput);
			Controls.Add(IdLabel);
			Controls.Add(IdInput);
			Controls.Add(OpenFile);
			Controls.Add(LimitLabel);
			Controls.Add(LimitInput);
			Controls.Add(CursorLabel);
			Controls.Add(CursorInput);
			Controls.Add(Info);
			Controls.Add(Download);
			Controls.Add(Output);
			ResumeLayout(false);
			PerformLayout();
			Show();
			MinimumSize = Size;
			IdInput.Focus();
		}
		protected override void Dispose(bool disposing) {
			if (disposing) {
				if (Logger != null) {
					Logger.Close();
					Logger.Dispose();
				}
				if (Graphics != null) {
					Graphics.Dispose();
				}
				if (Components != null) {
					Components.Dispose();
				}
			}
			base.Dispose(disposing);
		}
		public void DisableControls() {
			Stop = false;
			Info.Text = "stop";
			Download.Text = "stop";
			Log.Enabled = false;
			AddDate.Enabled = false;
			AddDescription.Enabled = false;
			ImproveQuality.Enabled = false;
			PreferHevc.Enabled = false;
			DirInput.ReadOnly = true;
			OpenDir.Enabled = false;
			TypeInput.Enabled = false;
			IdInput.ReadOnly = true;
			OpenFile.Enabled = false;
			LimitInput.ReadOnly = true;
			CursorInput.ReadOnly = true;
			Cursor.Current = Cursors.WaitCursor;
		}
		public void EnableControls() {
			if (Logger != null) {
				Logger.Close();
				Logger.Dispose();
				Logger = null;
			}
			Stop = false;
			Info.Text = "info";
			Download.Text = "download";
			Log.Enabled = true;
			AddDate.Enabled = true;
			AddDescription.Enabled = true;
			ImproveQuality.Enabled = true;
			PreferHevc.Enabled = true;
			DirInput.ReadOnly = false;
			OpenDir.Enabled = true;
			TypeInput.Enabled = true;
			IdInput.ReadOnly = false;
			OpenFile.Enabled = true;
			LimitInput.ReadOnly = false;
			CursorInput.ReadOnly = false;
			Cursor.Current = Cursors.Default;
		}
		public static double Max(params double[] values) {
			if (values.Length == 0) {
				return 0;
			}
			int i = 0;
			double m = values[0];
			do {
				if (m < values[i]) {
					m = values[i];
				}
				i++;
			} while (i < values.Length);
			return m;
		}
		public static string GetFullDir(string directory, string root) {
			if (directory.Length == 0) {
				return root;
			}
			string t;
			switch (directory[directory.Length - 1]) {
				case '/':
				case '\\':
					if (directory.Length == 1) {
						return root;
					}
					t = directory.Substring(0, directory.Length - 1);
					break;
				default:
					t = directory;
					break;
			}
			return Path.GetFullPath(Path.IsPathRooted(t) ? t : root + Path.DirectorySeparatorChar + t);
		}
		public static object FromJson(DataContractJsonSerializer serializer, string value) {
			using (MemoryStream t = new MemoryStream(Encoding.UTF8.GetBytes(value))) {
				return serializer.ReadObject(t);
			}
		}
		public static string ToJson(DataContractJsonSerializer serializer, object value) {
			using (MemoryStream t = new MemoryStream()) {
				serializer.WriteObject(t, value);
				return Encoding.UTF8.GetString(t.ToArray());
			}
		}
		public static string CreateTimeToString(long value) {
			return (new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).AddSeconds(value).ToString("yyyy-MM-dd HH':'mm':'ss");
		}
		public static string CreateTimeToFilename(long value) {
			return (new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).AddSeconds(value).ToString("yyyyMMddTHHmmssZ");
		}
		public static string CreateTimeToLog(long value) {
			return (new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).AddSeconds(value).ToString("yyyy-MM-ddTHH':'mm':'ssZ");
		}
		public static string SanitizeFilename(string value) {
			if (value.Length == 0) {
				return "";
			}
			int i = 0, e = 0;
			char[] r = new char[value.Length];
			do {
				switch (value[i]) {
					case '"':
					case '*':
					case '/':
					case ':':
					case '<':
					case '>':
					case '?':
					case '\\':
					case '|':
						break;
					default:
						if (value[i] >= ' ') {
							r[e] = value[i];
							e++;
						}
						break;
				}
				i++;
			} while (i < value.Length);
			return new string(r, 0, e);
		}
		public static string SanitizeLog(string value) {
			if (value.Length == 0) {
				return "";
			}
			int i = 0, e = 0;
			char[] r = new char[value.Length];
			do {
				switch (value[i]) {
					case '\r':
					case '\n':
						break;
					default:
						r[e] = value[i];
						e++;
						break;
				}
				i++;
			} while (i < value.Length);
			return new string(r, 0, e);
		}
		public static string ReplaceNewlines(string value, string replacement) {
			if (value.Length == 0) {
				return "";
			}
			int i = 0;
			switch (replacement.Length) {
				case 0: {
					char[] r = new char[value.Length];
					int e = 0;
					do {
						switch (value[i]) {
							case '\r':
							case '\n':
								break;
							default:
								r[e] = value[i];
								e++;
								break;
						}
						i++;
					} while (i < value.Length);
					return new string(r, 0, e);
				}
				case 1: {
					char[] r = new char[value.Length];
					int e = 0;
					do {
						switch (value[i]) {
							case '\r':
								r[e] = replacement[0];
								e++;
								i++;
								if (i == value.Length) {
									goto end;
								} else if (value[i] == '\n') {
									i++;
								}
								break;
							case '\n':
								r[e] = replacement[0];
								e++;
								i++;
								break;
							default:
								r[e] = value[i];
								e++;
								i++;
								break;
						}
					} while (i < value.Length);
					end: return new string(r, 0, e);
				}
				default: {
					StringBuilder r = new StringBuilder(replacement.Length);
					do {
						switch (value[i]) {
							case '\r':
								r.Append(replacement);
								i++;
								if (i == value.Length) {
									goto end;
								} else if (value[i] == '\n') {
									i++;
								}
								break;
							case '\n':
								r.Append(replacement);
								i++;
								break;
							default:
								r.Append(value[i]);
								i++;
								break;
						}
					} while (i < value.Length);
					end: return r.ToString();
				}
			}
		}
		/*public static string GenerateBase62(int length) {
			const string base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
			int i = 0;
			char[] a = new char[length];
			Random r = new Random();
			while (i < length) {
				a[i] = base62[r.Next(62)];
				i++;
			}
			return new string(a);
		}*/
		public static string GenerateDeviceId() {
			int i = 1;
			Random r = new Random();
			char[] a = new char[19];//11 + r.Next(9)
			a[0] = '6';//(char)(49 + r.Next(9))
			while (i < a.Length) {
				a[i] = (char)(48 + r.Next(10));
				i++;
			}
			return new string(a);
		}
		/*public static string ToBase36(long value) {
			if (value == long.MinValue) {
				return "-1y2p0ij32e8e8";
			}
			const string base36 = "0123456789abcdefghijklmnopqrstuvwxyz";
			bool n;
			int i = 13;
			char[] a = new char[14];
			if (n = value < 0) {
				value = -value;
			}
			do {
				a[i--] = base36[(byte)(value % 36)];
			} while ((value /= 36) != 0);
			if (n) {
				a[i--] = '-';
			}
			return new string(a, i + 1, 13 - i);
		}
		public static string GenerateVerify() {
			const string base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
			int i = 0;
			long t = (long)DateTime.UtcNow.Subtract(new DateTime(1970, 1, 1)).TotalMilliseconds;
			char[] a = new char[36];
			Random r = new Random();
			do {
				switch (i) {
					case 8:
					case 13:
					case 18:
					case 23:
						a[i] = '_';
						break;
					case 14:
						a[i] = '4';
						break;
					default:
						a[i] = base62[r.Next(62)];
						break;
				}
				i++;
			} while (i < 36);
			return "verify_" + ToBase36(t) + "_" + new string(a);
		}
		public static string GenerateCookie() {
			string t = GenerateDeviceId();
			return "tt_webid=" + t + "; tt_webid_v2=" + t + "; tt_csrf_token=" + GenerateBase62(24) + "; s_v_web_id=" + GenerateVerify();
		}*/
		/*public static string GeneratePublicIp() {
			int i0, i1, i2;
			Random r = new Random();
			while ((i0 = r.Next(1, 224)) == 10 || i0 == 127) {}
			switch (i0) {
				case 100:
					while ((i1 = r.Next(256)) > 63 && i1 < 128) {}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 169:
					while ((i1 = r.Next(256)) == 254) {}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 172:
					while ((i1 = r.Next(256)) > 15 && i1 < 32) {}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 192:
					while ((i1 = r.Next(256)) == 168) {}
					switch (i1) {
						case 0:
							while ((i2 = r.Next(1, 256)) == 2) {}
							return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
						case 88:
							while ((i2 = r.Next(256)) == 99) {}
							return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
					}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 198:
					while ((i1 = r.Next(256)) == 18 || i1 == 19) {}
					if (i1 == 51) {
						while ((i2 = r.Next(256)) == 100) {}
						return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
					}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
				case 203:
					if ((i1 = r.Next(256)) == 0) {
						while ((i2 = r.Next(256)) == 113) {}
						return i0.ToString() + "." + i1.ToString() + "." + i2.ToString() + "." + r.Next(256).ToString();
					}
					return i0.ToString() + "." + i1.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
			}
			return i0.ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString() + "." + r.Next(256).ToString();
		}*/
		/*public static string GenerateIp() {
			Random r = new Random();
			return r.Next(0, 256).ToString() + '.' + r.Next(0, 256).ToString() + '.' + r.Next(0, 256).ToString() + '.' + r.Next(0, 256).ToString();
		}*/
		public static bool ValidateId(string value) {
			if (value.Length == 0 || value.Length > 20 || value[0] < '1' || value[0] > '9') {
				return false;
			}
			for (int i = 1; i < value.Length; i++) {
				if (value[i] < '0' || value[i] > '9') {
					return false;
				}
			}
			return true;
		}
		public static void RandomizeDevices(string[,] values) {
			int i = 0, e = values.GetLength(0), j, y;
			string t0, t1;
			Random r = new Random();
			for (; i < e; i++) {
				j = r.Next(e);
				y = r.Next(e);
				t0 = values[j, 0];
				t1 = values[j, 1];
				values[j, 0] = values[y, 0];
				values[j, 1] = values[y, 1];
				values[y, 0] = t0;
				values[y, 1] = t1;
			}
		}
		public static string GetQualityUri(string value) {
			int i = value.IndexOf("?video_id="), e;
			if (i > -1 && (e = value.IndexOf("&", i + 10)) > -1) {
				return "https://api.tiktokv.com/aweme/v1/play/" + value.Substring(i, e - i) + "&improve_bitrate=1&ratio=default";
			}
			return value;
		}
		public static string GetQualityUri_(string value) {
			int i = value.IndexOf("?video_id="), e;
			if (i > -1 && (e = value.IndexOf("&", i + 10)) > -1) {
				return "https://api-h2.tiktokv.com/aweme/v1/play/" + value.Substring(i, e - i) + "&improve_bitrate=1&ratio=default";
			}
			return value;
		}
		public static string GetRedirect(string url) {
			int i = 0;
			string r = url;
			HttpWebRequest rq;
			HttpWebResponse rs;
			do {
				rq = (HttpWebRequest)HttpWebRequest.Create(url);
				rq.Method = "GET";
				rq.AllowAutoRedirect = false;
				rq.UserAgent = "Mozilla/5.0 AppleWebKit/537.36 Chrome/87.0.4280.88 Safari/537.36";
				using (rs = (HttpWebResponse)rq.GetResponse()) {
					if ((int)rs.StatusCode < 300 || (int)rs.StatusCode >= 400) {
						break;
					} else if ((r = rs.Headers.Get("Location")) == null) {
						r = url;
						break;
					} else if (r.IndexOf("://") == -1) {
						r = (new Uri(new Uri(url), r)).ToString();
					}
				}
				url = r;
				i++;
			} while (i < 9);
			return r;
		}
		public static string ExtractId(string url) {
			int i = 0, e = 0;
			while (i < url.Length) {
				if (url[i] >= '1' && url[i] <= '9' && i > 1 && url[i - 1] == '/') {
					e = i;
					i++;
					while (i < url.Length && url[i] >= '0' && url[i] <= '9') {
						i++;
					}
					if (e + 1 < i) {
						return url.Substring(e, i - e);
					}
				}
				i++;
			}
			return null;
		}
		public static string[] GetIds(string value) {
			if (value.Length == 0) {
				return null;
			}
			int i = 0, e = 0, j;
			String t0, t1;
			StringBuilder b = new StringBuilder();
			List<String> r = new List<String>();
			do {
				while (i < value.Length && value[i] <= ' ') {
					i++;
				}
				if (i == value.Length) {
					break;
				} else if (value[i] < '1' || value[i] > '9') {
					j = i;
					i++;
					while (i < value.Length && value[i] > ' ') {
						i++;
					}
					if ((t1 = ExtractId(t0 = value.Substring(j, i - j))) != null) {
						b.Append(t1);
					} else {
						try {
							if ((t1 = GetRedirect(t0)) != null && t1.Length > 0 && t1 != t0 && (t1 = ExtractId(t1)) != null) {
								b.Append(t1);
							}
						} catch (Exception) {
							if (i == value.Length) {
								break;
							}
							i++;
							continue;
						}
					}
					if (i == value.Length) {
						break;
					}
				} else {
					b.Append(value[i]);
					i++;
					while (i < value.Length && value[i] >= '0' && value[i] <= '9') {
						b.Append(value[i]);
						i++;
					}
					if (i == value.Length) {
						break;
					} else if (value[i] > ' ' && (value[i] < '1' || value[i] > '9')) {
						return null;
					}
				}
				if (e == 29) {
					r.Add(b.ToString());
					b.Length = 0;
					e = 0;
				} else {
					b.Append(',');
					e++;
				}
				i++;
			} while (i < value.Length);
			if (b.Length > 0) {
				if (b[b.Length - 1] == ',') {
					b.Length = b.Length - 1;
				}
				r.Add(b.ToString());
			}
			return r.ToArray();
		}
		public string[] GetVideoUrlList(VideoData value) {
			if (Hevc) {
				if (value.PlayAddr265 != null && value.PlayAddr265.UrlList != null && value.PlayAddr265.UrlList.Length > 0) {
					return value.PlayAddr265.UrlList;
				} else if (value.PlayAddrBytevc1 != null && value.PlayAddrBytevc1.UrlList != null && value.PlayAddrBytevc1.UrlList.Length > 0) {
					return value.PlayAddrBytevc1.UrlList;
				}
			}
			if (value.PlayAddr != null && value.PlayAddr.UrlList != null && value.PlayAddr.UrlList.Length > 0) {
				return value.PlayAddr.UrlList;
			}
			return null;
		}
		public string[] GetVideoUrlList(VideoData_ value) {
			if (Hevc) {
				if (value.PlayAddr265 != null && value.PlayAddr265.UrlList != null && value.PlayAddr265.UrlList.Length > 0) {
					return value.PlayAddr265.UrlList;
				} else if (value.PlayAddrBytevc1 != null && value.PlayAddrBytevc1.UrlList != null && value.PlayAddrBytevc1.UrlList.Length > 0) {
					return value.PlayAddrBytevc1.UrlList;
				}
			}
			if (value.PlayAddr != null && value.PlayAddr.UrlList != null && value.PlayAddr.UrlList.Length > 0) {
				return value.PlayAddr.UrlList;
			}
			return null;
		}
		public void DownloadAweme(object aweme) {
			Aweme a = (Aweme)aweme;
			try {
				bool f = false;
				int r = 0;
				string n, d = a.AddDate && a.Date > 0 ? CreateTimeToFilename(a.Date) : "", t = a.AddDescription && a.Description.Length > 0 ? SanitizeFilename(a.Description) : "";
				byte[] l;
				if (File.Exists(n = (d.Length > 0 ? a.Id + " " + d : a.Id) + (t.Length > 0 ? " " + t + ".mp4" : ".mp4"))) {
					return;
				}
				AwemeWebClient c = new AwemeWebClient();
				do {
					try {
						c.Headers.Set("User-Agent", "okhttp");
						c.DownloadFile(a.Url, n);
						if ((new FileInfo(n)).Length == 0) {
							File.Delete(n);
							throw new Exception("File is empty.");
						}
						break;
					} catch (PathTooLongException) {
						if (t.Length == 0 || f) {
							throw;
						} else if (File.Exists(n = (d.Length > 0 ? a.Id + " " + d : a.Id) + ".mp4")) {
							return;
						}
						f = true;
						r = 0;
					} catch (Exception) {
						if (r == 3) {
							File.Delete(n);
							throw;
						}
						r++;
					}
				} while (true);
				lock (OutLock) {
					Output.AppendText(a.Id);
					Output.AppendText(" is downloaded");
					Output.AppendText(Environment.NewLine);
					if (Logger != null) {
						l = Encoding.UTF8.GetBytes(a.Id + " " + CreateTimeToLog(a.Date) + " " + SanitizeLog(a.Description) + Environment.NewLine);
						Logger.Write(l, 0, l.Length);
					}
				}
			} catch (Exception x) {
				lock (OutLock) {
					Output.AppendText(a.Id);
					Output.AppendText(" failed");
					Output.AppendText(Environment.NewLine);
					Output.AppendText(x.InnerException != null ? x.InnerException.Message : x.Message);
					Output.AppendText(Environment.NewLine);
				}
			} finally {
				lock (SyncLock) {
					Count--;
					Monitor.Pulse(SyncLock);
				}
			}
		}
		public bool RequestAweme(WebClient client, DataContractJsonSerializer serializer, string path, out object result) {
			TimeSpan t;
			Stream s;
			Thread.Sleep(1000);
			do {
				lock (StopLock) {
					if (Stop) {
						break;
					}
				}
				t = DateTime.UtcNow.Subtract(new DateTime(1970, 1, 1));
				try {
					client.Headers.Set("User-Agent", "okhttp");
					/*if (Ip.Length > 0) {
						client.Headers.Set("X-Forwarded-For", Ip);
					}*/
					using (s = client.OpenRead("https://api-t2.tiktokv.com" + path
					+ "&region=US"
					//+ "&version_name=10.0.1"
					+ "&ts=" + ((int)t.TotalSeconds).ToString()
					+ "&timezone_name=Etc%2FGMT"
					+ "&device_type=Pixel%202"// + DeviceVersion
					+ "&iid=" + Devices[Device, 1]
					+ "&locale=en"
					+ "&app_type=normal"
					//+ "&build_number=10.0.1"
					+ "&resolution=1080*1920"
					+ "&aid=1180"
					+ "&app_name=musical_ly"
					+ "&_rticket=" + ((long)t.TotalMilliseconds).ToString()
					+ "&device_platform=android"
					+ "&version_code=100001"
					+ "&dpi=441"
					+ "&cpu_support64=false"
					+ "&sys_region=US"
					+ "&timezone_offset=0"
					+ "&device_id=" + Devices[Device, 0]
					+ "&pass-route=1"
					+ "&device_brand=google"
					+ "&os_version=8.0.1"//+ Os
					//+ "&ab_version=10.0.1"
					+ "&op_region=US"
					+ "&app_language=en"
					+ "&pass-region=1"
					+ "&language=en"
					+ "&channel=googleplay"
					+ (Hevc ? "&version_name=10.0.1&build_number=10.0.1" : ""))) {
						result = serializer.ReadObject(s);
						return true;
					}
				} catch {
					//Os = GenerateBase62(16);
					//Ip = GeneratePublicIp();
					//DeviceVersion = GenerateBase62(8);
					Device++;
					if (Device >= Devices.GetLength(0)) {//SerializationException or else
						RandomizeDevices(Devices);
						Device = 0;
						//Ip = "";
						throw;
					}
				}
			} while (true);
			result = null;
			return false;
		}
		public bool RequestTiktok(WebClient client, DataContractJsonSerializer serializer, string path, out object result) {
			int r = 0;
			Stream s;
			//Thread.Sleep(1000);
			do {
				lock (StopLock) {
					if (Stop) {
						break;
					}
				}
				try {
					client.Headers.Set("User-Agent", "Mozilla/5.0 AppleWebKit/537.36 Chrome/87.0.4280.88 Safari/537.36");
					client.Headers.Set("Referer", "https://www.tiktok.com/");
					//client.Headers.Set("Cookie", Cookie);
					using (s = client.OpenRead("https://www.tiktok.com" + path)) {
						result = serializer.ReadObject(s);
						return true;
					}
				} catch {
					//Cookie = GenerateCookie();
					if (r == 9) {//SerializationException or else
						throw;
					}
					r++;
				}
			} while (true);
			result = null;
			return false;
		}
		/*public static string GetFlvStream(string value) {
			int i = value.IndexOf("-hls-"), e;
			if (i > -1 && ((e = value.IndexOf("/playlist.m3u8", i + 5)) > -1 || (e = value.IndexOf("/index.m3u8", i + 5)) > -1)) {
				return value.Substring(0, i) + "-flv-" + value.Substring(i + 5, e - i - 5) + ".flv";
			}
			return "";
		}
		public static string FindStream(string value) {
			/*int i = value.IndexOf("<script id=\"RENDER_DATA\" type=\"application/json\">"), e;
			if (i == -1 || (e = value.IndexOf("</script>", i += 49)) == -1) {
				return "";
			}
			value = Uri.UnescapeDataString(value.Substring(i, e - i));* /
			int i = value.IndexOf("\"LiveUrl\""), e;
			if (i == -1) {
				return "";
			}
			e = i + 9;
			while (e < value.Length && (value[e] == ' ' || value[e] == '\n' || value[e] == '\r' || value[e] == '\t')) {
				e++;
			}
			if (e == value.Length || value[e] != ':') {
				return "";
			}
			e++;
			while (e < value.Length && (value[e] == ' ' || value[e] == '\n' || value[e] == '\r' || value[e] == '\t')) {
				e++;
			}
			if (e == value.Length || value[e] != '"') {
				return "";
			}
			e++;
			i = e;
			while (e < value.Length && value[e] != '"') {
				e++;
			}
			if (e == value.Length) {
				return "";
			}
			return value.Substring(i, e - i);
		}
		public static string RequestStream(long id) {
			try {
				WebClient c = new WebClient();
				c.Headers.Set("User-Agent", "okhttp");
				return FindStream(c.DownloadString("https://www.tiktok.com/share/live/" + id.ToString()));
			} catch (Exception) {
				return "";
			}
		}*/
		/*public bool GetUserId(string name, out string result) {
			object r;
			UserNode o;
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(UserNode)), "/node/share/user/@" + Uri.EscapeUriString(name), out r)) {
				result = null;
				return false;
			}
			result = (o = (UserNode)r) != null && o.UserInfo != null && o.UserInfo.User != null ? o.UserInfo.User.Id : null;
			return true;
		}
		public bool GetHashtagId(string tag, out string result) {
			object r;
			ChallengeNode o;
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(ChallengeNode)), "/node/share/tag/" + Uri.EscapeUriString(tag), out r)) {
				result = null;
				return false;
			}
			result = (o = (ChallengeNode)r) != null && o.ChallengeInfo != null && o.ChallengeInfo.Challenge != null ? o.ChallengeInfo.Challenge.Id : null;
			return true;
		}*/
		public bool GetUserId(string name, out string result) {
			int i;
			object r;
			UserSearch o;
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(UserSearch)), "/api/discover/user/"
			+ "?discoverType=1"
			+ "&needItemList=false"
			+ "&useRecommend=false"
			+ "&keyWord=" + Uri.EscapeDataString(name)
			+ "&offset=0"
			+ "&count=20"
			+ "&aid=1988"
			+ "&appId=1233"
			+ "&appType=m"
			+ "&app_name=tiktok_web"
			+ "&device_platform=web"
			+ "&language=en", out r)) {
				result = null;
				return false;
			} else if ((o = (UserSearch)r) != null && o.UserInfoList != null) {
				for (i = 0, name = name.ToLower(); i < o.UserInfoList.Length; i++) {
					if (o.UserInfoList[i].User != null && o.UserInfoList[i].User.UniqueId != null && o.UserInfoList[i].User.UniqueId.ToLower() == name) {
						result = o.UserInfoList[i].User.Id;
						return true;
					}
				}
			}
			result = null;
			return true;
		}
		public bool GetHashtagId(string tag, out string result) {
			int i;
			object r;
			ChallengeSearch o;
			if (!RequestTiktok(new WebClient(), new DataContractJsonSerializer(typeof(ChallengeSearch)), "/api/discover/challenge/"
			+ "?discoverType=1"
			+ "&needItemList=false"
			+ "&useRecommend=false"
			+ "&keyWord=" + Uri.EscapeDataString(tag)
			+ "&offset=0"
			+ "&count=20"
			+ "&aid=1988"
			+ "&appId=1233"
			+ "&appType=m"
			+ "&app_name=tiktok_web"
			+ "&device_platform=web"
			+ "&language=en", out r)) {
				result = null;
				return false;
			} else if ((o = (ChallengeSearch)r) != null && o.ChallengeInfoList != null) {
				for (i = 0, tag = tag.ToLower(); i < o.ChallengeInfoList.Length; i++) {
					if (o.ChallengeInfoList[i].Challenge != null && o.ChallengeInfoList[i].Challenge.Title != null && o.ChallengeInfoList[i].Challenge.Title.ToLower() == tag) {
						result = o.ChallengeInfoList[i].Challenge.Id;
						return true;
					}
				}
			}
			result = null;
			return true;
		}
		/*public void OutputLiveInfo(string roomId) {
			if (roomId == null) {
				return;
			}
			string t;
			if ((t = RequestStream(roomId)).Length > 0) {
				Output.AppendText("hls stream: ");
				Output.AppendText(t);
				Output.AppendText(Environment.NewLine);
				t = GetFlvStream(t);
				if (t.Length > 0) {
					Output.AppendText("flv stream: ");
					Output.AppendText(t);
					Output.AppendText(Environment.NewLine);
				}
			}
		}*/
		public void OutputLiveInfo(string roomData) {
			if (roomData == null) {
				return;
			}
			RoomData rd = (RoomData)FromJson(new DataContractJsonSerializer(typeof(RoomData)), roomData);
			StreamData sd;
			if (rd == null || rd.StreamUrl == null || rd.StreamUrl.LiveCoreSdkData == null || rd.StreamUrl.LiveCoreSdkData.PullData == null || rd.StreamUrl.LiveCoreSdkData.PullData.StreamData == null) {
				return;
			}
			sd = (StreamData)FromJson(new DataContractJsonSerializer(typeof(StreamData)), rd.StreamUrl.LiveCoreSdkData.PullData.StreamData);
			if (sd == null || sd.Data == null || sd.Data.Origin == null || sd.Data.Origin.Main == null) {
				return;
			}
			if (sd.Data.Origin.Main.Hls != null && sd.Data.Origin.Main.Hls.Length > 0) {
				Output.AppendText("hls stream: ");
				Output.AppendText(sd.Data.Origin.Main.Hls);
				Output.AppendText(Environment.NewLine);
			}
			if (sd.Data.Origin.Main.Flv != null && sd.Data.Origin.Main.Flv.Length > 0) {
				Output.AppendText("flv stream: ");
				Output.AppendText(sd.Data.Origin.Main.Flv);
				Output.AppendText(Environment.NewLine);
			}
		}
		public void OutputUserInfo(UserData user) {
			Output.AppendText("id: ");
			Output.AppendText(user.Uid);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("unique id: ");
			Output.AppendText(user.UniqueId);
			Output.AppendText(Environment.NewLine);
			if (user.SecUid != null && user.SecUid.Length > 0) {
				Output.AppendText("secure id: ");
				Output.AppendText(user.SecUid);
				Output.AppendText(Environment.NewLine);
			}
			Output.AppendText("nickname: ");
			Output.AppendText(user.Nickname);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("private: ");
			Output.AppendText(user.Secret != 0 ? "true" : "false");
			Output.AppendText(Environment.NewLine);
			Output.AppendText("videos: ");
			Output.AppendText(user.AwemeCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("favorites: ");
			Output.AppendText(user.FavoritingCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("favorited: ");
			Output.AppendText(user.TotalFavorited.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("followings: ");
			Output.AppendText(user.FollowingCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("followers: ");
			Output.AppendText(user.FollowerCount.ToString());
			Output.AppendText(Environment.NewLine);
			if (user.AvatarLarger != null && user.AvatarLarger.UrlList != null && user.AvatarLarger.UrlList.Length > 0 && user.AvatarLarger.UrlList[0] != null) {
				Output.AppendText("avatar: ");
				Output.AppendText(user.AvatarLarger.UrlList[0]);
				Output.AppendText(Environment.NewLine);
			}
			if (user.VideoIcon != null && user.VideoIcon.UrlList != null && user.VideoIcon.UrlList.Length > 0 && user.VideoIcon.UrlList[0] != null) {
				Output.AppendText("dynamic avatar: ");
				Output.AppendText(user.VideoIcon.UrlList[0]);
				Output.AppendText(Environment.NewLine);
			}
			if (user.RoomId != 0) {
				Output.AppendText("live: ");
				Output.AppendText(user.RoomId.ToString());
				Output.AppendText(Environment.NewLine);
				try {
					OutputLiveInfo(user.RoomData);//user.RoomId
				} catch (Exception) {}
			}
			if (user.Signature != null && user.Signature.Length > 0) {
				Output.AppendText(ReplaceNewlines(user.Signature, Environment.NewLine));
				Output.AppendText(Environment.NewLine);
			}
			if (user.InsId != null && user.InsId.Length > 0) {
				Output.AppendText("https://www.instagram.com/");
				Output.AppendText(user.InsId);
				Output.AppendText("/");
				Output.AppendText(Environment.NewLine);
			}
			if (user.YoutubeChannelId != null && user.YoutubeChannelId.Length > 0) {
				Output.AppendText("https://www.youtube.com/channel/");
				Output.AppendText(user.YoutubeChannelId);
				Output.AppendText(Environment.NewLine);
			}
			if (user.BioUrl != null && user.BioUrl.Length > 0) {
				Output.AppendText(user.BioUrl);
				Output.AppendText(Environment.NewLine);
			}
		}
		public void OutputMusicInfo(MusicData music) {
			Output.AppendText("id: ");
			Output.AppendText(music.Mid);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("title: ");
			Output.AppendText(music.Title);
			Output.AppendText(Environment.NewLine);
			if (music.OwnerId != null && music.OwnerId.Length > 0 && music.OwnerId != "0"
			&& music.OwnerHandle != null && music.OwnerHandle.Length > 0) {
				Output.AppendText("author id: ");
				Output.AppendText(music.OwnerId);
				Output.AppendText(Environment.NewLine);
				Output.AppendText("author unique id: ");
				Output.AppendText(music.OwnerHandle);
				Output.AppendText(Environment.NewLine);
				if (music.SecUid != null && music.SecUid.Length > 0) {
					Output.AppendText("author secure id: ");
					Output.AppendText(music.SecUid);
					Output.AppendText(Environment.NewLine);
				}
				Output.AppendText("author nickname: ");
				Output.AppendText(music.Author);
				Output.AppendText(Environment.NewLine);
			} else {
				Output.AppendText("author: ");
				Output.AppendText(music.Author);
				Output.AppendText(Environment.NewLine);
			}
			Output.AppendText("videos: ");
			Output.AppendText(music.UserCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("duration: ");
			Output.AppendText(music.Duration.ToString());
			Output.AppendText(Environment.NewLine);
			if (music.CoverHd != null && music.CoverHd.UrlList != null && music.CoverHd.UrlList.Length > 0 && music.CoverHd.UrlList[0] != null) {
				Output.AppendText("cover: ");
				Output.AppendText(music.CoverHd.UrlList[0]);
				Output.AppendText(Environment.NewLine);
			}
			if (music.PlayUrl != null && music.PlayUrl.UrlList != null && music.PlayUrl.UrlList.Length > 0 && music.PlayUrl.UrlList[0] != null) {
				Output.AppendText("play: ");
				Output.AppendText(music.PlayUrl.UrlList[0]);
				Output.AppendText(Environment.NewLine);
			}
		}
		public void OutputChallengeInfo(ChallengeData hashtag) {
			Output.AppendText("id: ");
			Output.AppendText(hashtag.Cid);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("tag: ");
			Output.AppendText(hashtag.ChaName);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("videos: ");
			Output.AppendText(hashtag.UserCount.ToString());
			Output.AppendText(Environment.NewLine);
			Output.AppendText("views: ");
			Output.AppendText(hashtag.ViewCount.ToString());
			Output.AppendText(Environment.NewLine);
			if (hashtag.HashtagProfile != null && hashtag.HashtagProfile.Length > 0) {
				Output.AppendText("cover: ");
				Output.AppendText(hashtag.HashtagProfile);
				Output.AppendText(Environment.NewLine);
			}
			if (hashtag.Desc != null && hashtag.Desc.Length > 0) {
				Output.AppendText(ReplaceNewlines(hashtag.Desc, Environment.NewLine));
				Output.AppendText(Environment.NewLine);
			}
		}
		public void OutputVideoInfo(AwemeDetailData_ video) {
			string[] u;
			Output.AppendText("id: ");
			Output.AppendText(video.AwemeId);
			Output.AppendText(Environment.NewLine);
			Output.AppendText("created: ");
			Output.AppendText(CreateTimeToString(video.CreateTime));
			Output.AppendText(Environment.NewLine);
			if (video.Statistics != null) {
				Output.AppendText("views: ");
				Output.AppendText(video.Statistics.PlayCount.ToString());
				Output.AppendText(Environment.NewLine);
				Output.AppendText("likes: ");
				Output.AppendText(video.Statistics.DiggCount.ToString());
				Output.AppendText(Environment.NewLine);
				Output.AppendText("comments: ");
				Output.AppendText(video.Statistics.CommentCount.ToString());
				Output.AppendText(Environment.NewLine);
				Output.AppendText("shares: ");
				Output.AppendText(video.Statistics.ShareCount.ToString());
				Output.AppendText(Environment.NewLine);
				Output.AppendText("downloads: ");
				Output.AppendText(video.Statistics.DownloadCount.ToString());
				Output.AppendText(Environment.NewLine);
			}
			if (video.Video != null) {
				if (video.Video.OriginCover != null && video.Video.OriginCover.UrlList != null && video.Video.OriginCover.UrlList.Length > 0 && video.Video.OriginCover.UrlList[0] != null) {
					Output.AppendText("cover: ");
					Output.AppendText(video.Video.OriginCover.UrlList[0]);
					Output.AppendText(Environment.NewLine);
				}
				if (video.Video.DynamicCover != null && video.Video.DynamicCover.UrlList != null && video.Video.DynamicCover.UrlList.Length > 0 && video.Video.DynamicCover.UrlList[0] != null) {
					Output.AppendText("dynamic cover: ");
					Output.AppendText(video.Video.DynamicCover.UrlList[0]);
					Output.AppendText(Environment.NewLine);
				}
				if ((u = GetVideoUrlList(video.Video)) != null) {
					Output.AppendText("play: ");
					Output.AppendText(Quality ? GetQualityUri_(u[u.Length - 1]) : u[0]);
					Output.AppendText(Environment.NewLine);
				}
			}
			if (video.Desc != null && video.Desc.Length > 0) {
				Output.AppendText(ReplaceNewlines(video.Desc, Environment.NewLine));
				Output.AppendText(Environment.NewLine);
			}
			if (video.Music != null) {
				Output.AppendText("music id: ");
				Output.AppendText(video.Music.Mid);
				Output.AppendText(Environment.NewLine);
				Output.AppendText("music title: ");
				Output.AppendText(video.Music.Title);
				Output.AppendText(Environment.NewLine);
				if (video.Music.OwnerId != null && video.Music.OwnerId.Length > 0 && video.Music.OwnerId != "0"
				&& video.Music.OwnerHandle != null && video.Music.OwnerHandle.Length > 0) {
					Output.AppendText("music author id: ");
					Output.AppendText(video.Music.OwnerId);
					Output.AppendText(Environment.NewLine);
					Output.AppendText("music author unique id: ");
					Output.AppendText(video.Music.OwnerHandle);
					Output.AppendText(Environment.NewLine);
					if (video.Music.SecUid != null && video.Music.SecUid.Length > 0) {
						Output.AppendText("music author secure id: ");
						Output.AppendText(video.Music.SecUid);
						Output.AppendText(Environment.NewLine);
					}
					Output.AppendText("music author nickname: ");
					Output.AppendText(video.Music.Author);
					Output.AppendText(Environment.NewLine);
				} else {
					Output.AppendText("music author: ");
					Output.AppendText(video.Music.Author);
					Output.AppendText(Environment.NewLine);
				}
				Output.AppendText("music duration: ");
				Output.AppendText(video.Music.Duration.ToString());
				Output.AppendText(Environment.NewLine);
				if (video.Music.CoverHd != null && video.Music.CoverHd.UrlList != null && video.Music.CoverHd.UrlList.Length > 0 && video.Music.CoverHd.UrlList[0] != null) {
					Output.AppendText("music cover: ");
					Output.AppendText(video.Music.CoverHd.UrlList[0]);
					Output.AppendText(Environment.NewLine);
				}
				if (video.Music.PlayUrl != null && video.Music.PlayUrl.UrlList != null && video.Music.PlayUrl.UrlList.Length > 0 && video.Music.PlayUrl.UrlList[0] != null) {
					Output.AppendText("music play: ");
					Output.AppendText(video.Music.PlayUrl.UrlList[0]);
					Output.AppendText(Environment.NewLine);
				}
			}
			if (video.Author != null) {
				Output.AppendText("user id: ");
				Output.AppendText(video.Author.Uid);
				Output.AppendText(Environment.NewLine);
				Output.AppendText("user unique id: ");
				Output.AppendText(video.Author.UniqueId);
				Output.AppendText(Environment.NewLine);
				if (video.Author.SecUid != null && video.Author.SecUid.Length > 0) {
					Output.AppendText("user secure id: ");
					Output.AppendText(video.Author.SecUid);
					Output.AppendText(Environment.NewLine);
				}
				Output.AppendText("user nickname: ");
				Output.AppendText(video.Author.Nickname);
				Output.AppendText(Environment.NewLine);
				Output.AppendText("user private: ");
				Output.AppendText(video.Author.Secret != 0 ? "true" : "false");
				Output.AppendText(Environment.NewLine);
				if (video.Author.AvatarLarger != null && video.Author.AvatarLarger.UrlList != null && video.Author.AvatarLarger.UrlList.Length > 0 && video.Author.AvatarLarger.UrlList[0] != null) {
					Output.AppendText("user avatar: ");
					Output.AppendText(video.Author.AvatarLarger.UrlList[0]);
					Output.AppendText(Environment.NewLine);
				}
				if (video.Author.VideoIcon != null && video.Author.VideoIcon.UrlList != null && video.Author.VideoIcon.UrlList.Length > 0 && video.Author.VideoIcon.UrlList[0] != null) {
					Output.AppendText("user dynamic avatar: ");
					Output.AppendText(video.Author.VideoIcon.UrlList[0]);
					Output.AppendText(Environment.NewLine);
				}
				if (video.Author.Signature != null && video.Author.Signature.Length > 0) {
					Output.AppendText(ReplaceNewlines(video.Author.Signature, Environment.NewLine));
					Output.AppendText(Environment.NewLine);
				}
			}
		}
		public void InfoUser(object idOrName) {
			try {
				string i = (string)idOrName;
				object r;
				UserInfoData o;
				if (i[0] == '@') {
					if (!GetUserId(i.Substring(1), out i)) {
						goto end;
					} else if (i == null) {
						throw new Exception("Data is null.");
					}
				}
				if (!RequestAweme(new WebClient(), new DataContractJsonSerializer(typeof(UserInfoData)), "/aweme/v1/user/"///aweme/v1/user/profile/other/
				+ "?user_id=" + i//sec_user_id
				+ "&address_book_access=1"
				+ "&from=0", out r)) {
					goto end;
				} else if ((o = (UserInfoData)r) == null || o.User == null) {
					throw new Exception("Data is null.");
				}
				OutputUserInfo(o.User);
			} catch (Exception x) {
				Output.AppendText(x.Message);
				Output.AppendText(Environment.NewLine);
			}
			end: EnableControls();
		}
		public void InfoMusic(object id) {
			try {
				object r;
				MusicInfoData o;
				if (!RequestAweme(new WebClient(), new DataContractJsonSerializer(typeof(MusicInfoData)), "/aweme/v1/music/detail/"
				+ "?music_id=" + (string)id
				+ "&click_reason=0", out r)) {
					goto end;
				} else if ((o = (MusicInfoData)r) == null || o.MusicInfo == null) {
					throw new Exception("Data is null.");
				}
				OutputMusicInfo(o.MusicInfo);
			} catch (Exception x) {
				Output.AppendText(x.Message);
				Output.AppendText(Environment.NewLine);
			}
			end: EnableControls();
		}
		public void InfoChallenge(object idOrTag) {
			try {
				string i = (string)idOrTag;
				object r;
				ChallengeInfoData o;
				if (i[0] == '#') {
					if (!GetHashtagId(i.Substring(1), out i)) {
						goto end;
					} else if (i == null) {
						throw new Exception("Data is null.");
					}
				}
				if (!RequestAweme(new WebClient(), new DataContractJsonSerializer(typeof(ChallengeInfoData)), "/aweme/v1/challenge/detail/"
				+ "?ch_id=" + i
				+ "&click_reason=0"
				+ "&query_type=0", out r)) {
					goto end;
				} else if ((o = (ChallengeInfoData)r) == null || o.ChInfo == null) {
					throw new Exception("Data is null.");
				}
				OutputChallengeInfo(o.ChInfo);
			} catch (Exception x) {
				Output.AppendText(x.Message);
				Output.AppendText(Environment.NewLine);
			}
			end: EnableControls();
		}
		public void InfoVideo(object id) {
			try {
				object r;
				VideoInfoData o;
				if (!RequestAweme(new WebClient(), new DataContractJsonSerializer(typeof(VideoInfoData)), "/aweme/v1/aweme/detail/"
				+ "?aweme_id=" + (string)id
				+ "&click_reason=0", out r)) {
					goto end;
				} else if ((o = (VideoInfoData)r) == null || o.AwemeDetail == null) {
					throw new Exception("Data is null.");
				}
				OutputVideoInfo(o.AwemeDetail);
			} catch (Exception x) {
				Output.AppendText(x.Message);
				Output.AppendText(Environment.NewLine);
			}
			end: EnableControls();
		}
		public void DownloadUserVideos(object download) {
			long cu = 0;
			try {
				Download d = (Download)download;
				cu = d.Cursor;
				long i = 0, e = 0;
				string[] u;
				object r;
				WebClient c = new WebClient();
				DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(UserVideosData));
				UserVideosData o;
				if (d.Id[0] == '@') {
					if (!GetUserId(d.Id.Substring(1), out d.Id)) {
						goto end;
					} else if (d.Id == null) {
						throw new Exception("Data is null.");
					}
				}
				do {
					if (!RequestAweme(c, js, "/aweme/v1/aweme/post/"
					+ "?source=0"
					+ "&max_cursor=" + cu.ToString()
					+ "&user_id=" + d.Id//sec_user_id
					+ "&count=30", out r)) {
						break;
					}
					o = (UserVideosData)r;
					if (o == null) {
						lock (OutLock) {
							Output.AppendText("Data is null.");
							Output.AppendText(Environment.NewLine);
						}
						break;
					} else if (o.AwemeList != null) {
						for (i = 0; i < o.AwemeList.Length; i++, e++) {
							if (d.IsMax) {
								if (e == d.Limit) {
									o.HasMore = 0;
									break;
								}
							} else if (o.AwemeList[i].CreateTime < d.Limit) {
								o.HasMore = 0;
								break;
							}
							if (o.AwemeList[i].Video != null && (u = GetVideoUrlList(o.AwemeList[i].Video)) != null) {
								lock (SyncLock) {
									Count++;
								}
								new Thread(new ParameterizedThreadStart(DownloadAweme)).Start(new Aweme {
									Id = o.AwemeList[i].AwemeId,
									Date = o.AwemeList[i].CreateTime,
									Description = o.AwemeList[i].Desc != null ? o.AwemeList[i].Desc : "",
									Url = Quality ? GetQualityUri(u[u.Length - 1]) : u[0],
									AddDate = Date,
									AddDescription = Description
								});
								lock (SyncLock) {
									if (Count >= 10) {
										Monitor.Wait(SyncLock);
									}
								}
							}
						}
					}
					if (o.HasMore == 0) {
						break;
					}
					cu = o.MaxCursor;
				} while (true);
			} catch (Exception x) {
				lock (OutLock) {
					Output.AppendText(x.Message);
					Output.AppendText(Environment.NewLine);
				}
			}
			do {
				lock (SyncLock) {
					if (Count == 0) {
						break;
					}
					Monitor.Wait(SyncLock);
				}
			} while (true);
			end: Output.AppendText("cursor is ");
			Output.AppendText(cu.ToString());
			Output.AppendText(Environment.NewLine);
			EnableControls();
		}
		public void DownloadUserFavorites(object download) {
			long cu = 0;
			try {
				Download d = (Download)download;
				cu = d.Cursor;
				long i = 0, e = 0;
				string[] u;
				object r;
				WebClient c = new WebClient();
				DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(UserVideosData));
				UserVideosData o;
				if (d.Id[0] == '@') {
					if (!GetUserId(d.Id.Substring(1), out d.Id)) {
						goto end;
					} else if (d.Id == null) {
						throw new Exception("Data is null.");
					}
				}
				do {
					if (!RequestAweme(c, js, "/aweme/v1/aweme/favorite/"
					+ "?invalid_item_count=0"
					+ "&is_hiding_invalid_item=0"
					+ "&max_cursor=" + cu.ToString()
					+ "&user_id=" + d.Id//sec_user_id
					+ "&count=30", out r)) {
						break;
					}
					o = (UserVideosData)r;
					if (o == null) {
						lock (OutLock) {
							Output.AppendText("Data is null.");
							Output.AppendText(Environment.NewLine);
						}
						break;
					} else if (o.AwemeList != null) {
						for (i = 0; i < o.AwemeList.Length; i++, e++) {
							if (e == d.Limit) {
								o.HasMore = 0;
								break;
							} else if (o.AwemeList[i].Video != null && (u = GetVideoUrlList(o.AwemeList[i].Video)) != null) {
								lock (SyncLock) {
									Count++;
								}
								new Thread(new ParameterizedThreadStart(DownloadAweme)).Start(new Aweme {
									Id = o.AwemeList[i].AwemeId,
									Date = o.AwemeList[i].CreateTime,
									Description = o.AwemeList[i].Desc != null ? o.AwemeList[i].Desc : "",
									Url = Quality ? GetQualityUri(u[u.Length - 1]) : u[0],
									AddDate = Date,
									AddDescription = Description
								});
								lock (SyncLock) {
									if (Count >= 10) {
										Monitor.Wait(SyncLock);
									}
								}
							}
						}
					}
					if (o.HasMore == 0) {
						break;
					}
					cu = o.MaxCursor;
				} while (true);
			} catch (Exception x) {
				lock (OutLock) {
					Output.AppendText(x.Message);
					Output.AppendText(Environment.NewLine);
				}
			}
			do {
				lock (SyncLock) {
					if (Count == 0) {
						break;
					}
					Monitor.Wait(SyncLock);
				}
			} while (true);
			end: Output.AppendText("cursor is ");
			Output.AppendText(cu.ToString());
			Output.AppendText(Environment.NewLine);
			EnableControls();
		}
		public void DownloadMusicVideos(object download) {
			long cu = 0;
			try {
				Download d = (Download)download;
				cu = d.Cursor;
				long i = 0, e = 0;
				string[] u;
				object r;
				WebClient c = new WebClient();
				DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(MusicVideosData));
				MusicVideosData o;
				do {
					if (!RequestAweme(c, js, "/aweme/v1/music/aweme/"
					+ "?music_id=" + d.Id
					+ "&cursor=" + cu.ToString()
					+ "&count=30"
					+ "&type=0", out r)) {//&type=6
						break;
					}
					o = (MusicVideosData)r;
					if (o == null) {
						lock (OutLock) {
							Output.AppendText("Data is null.");
							Output.AppendText(Environment.NewLine);
						}
						break;
					} else if (o.AwemeList != null) {
						for (i = 0; i < o.AwemeList.Length; i++, e++) {
							if (e == d.Limit) {
								o.HasMore = 0;
								break;
							} else if (o.AwemeList[i].Video != null && (u = GetVideoUrlList(o.AwemeList[i].Video)) != null) {
								lock (SyncLock) {
									Count++;
								}
								new Thread(new ParameterizedThreadStart(DownloadAweme)).Start(new Aweme {
									Id = o.AwemeList[i].AwemeId,
									Date = o.AwemeList[i].CreateTime,
									Description = o.AwemeList[i].Desc != null ? o.AwemeList[i].Desc : "",
									Url = Quality ? GetQualityUri(u[u.Length - 1]) : u[0],
									AddDate = Date,
									AddDescription = Description
								});
								lock (SyncLock) {
									if (Count >= 10) {
										Monitor.Wait(SyncLock);
									}
								}
							}
						}
					}
					if (o.HasMore == 0) {
						break;
					}
					cu = o.Cursor;
				} while (true);
			} catch (Exception x) {
				lock (OutLock) {
					Output.AppendText(x.Message);
					Output.AppendText(Environment.NewLine);
				}
			}
			do {
				lock (SyncLock) {
					if (Count == 0) {
						break;
					}
					Monitor.Wait(SyncLock);
				}
			} while (true);
			Output.AppendText("cursor is ");
			Output.AppendText(cu.ToString());
			Output.AppendText(Environment.NewLine);
			EnableControls();
		}
		public void DownloadChallengeVideos(object download) {
			long cu = 0;
			try {
				Download d = (Download)download;
				cu = d.Cursor;
				long i = 0, e = 0;
				string[] u;
				object r;
				WebClient c = new WebClient();
				DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(ChallengeVideosData));
				ChallengeVideosData o;
				if (d.Id[0] == '#') {
					if (!GetHashtagId(d.Id.Substring(1), out d.Id)) {
						goto end;
					} else if (d.Id == null) {
						throw new Exception("Data is null.");
					}
				}
				do {
					if (!RequestAweme(c, js, "/aweme/v1/challenge/aweme/"
					+ "?ch_id=" + d.Id
					+ "&cursor=" + cu.ToString()
					+ "&count=30"
					+ "&query_type=0"
					+ "&source=challenge_video"
					+ "&type=5", out r)) {
						break;
					}
					o = (ChallengeVideosData)r;
					if (o == null) {
						lock (OutLock) {
							Output.AppendText("Data is null.");
							Output.AppendText(Environment.NewLine);
						}
						break;
					} else if (o.AwemeList != null) {
						for (i = 0; i < o.AwemeList.Length; i++, e++) {
							if (e == d.Limit) {
								o.HasMore = 0;
								break;
							} else if (o.AwemeList[i].Video != null && (u = GetVideoUrlList(o.AwemeList[i].Video)) != null) {
								lock (SyncLock) {
									Count++;
								}
								new Thread(new ParameterizedThreadStart(DownloadAweme)).Start(new Aweme {
									Id = o.AwemeList[i].AwemeId,
									Date = o.AwemeList[i].CreateTime,
									Description = o.AwemeList[i].Desc != null ? o.AwemeList[i].Desc : "",
									Url = Quality ? GetQualityUri(u[u.Length - 1]) : u[0],
									AddDate = Date,
									AddDescription = Description
								});
								lock (SyncLock) {
									if (Count >= 10) {
										Monitor.Wait(SyncLock);
									}
								}
							}
						}
					}
					if (o.HasMore == 0) {
						break;
					}
					cu = o.Cursor;
				} while (true);
			} catch (Exception x) {
				lock (OutLock) {
					Output.AppendText(x.Message);
					Output.AppendText(Environment.NewLine);
				}
			}
			do {
				lock (SyncLock) {
					if (Count == 0) {
						break;
					}
					Monitor.Wait(SyncLock);
				}
			} while (true);
			end: Output.AppendText("cursor is ");
			Output.AppendText(cu.ToString());
			Output.AppendText(Environment.NewLine);
			EnableControls();
		}
		public void DownloadVideos(object download) {
			try {
				Download d = (Download)download;
				long i = 0, e = 0, j = 0;
				string[] v, u;
				object r;
				WebClient c = new WebClient();
				DataContractJsonSerializer js = new DataContractJsonSerializer(typeof(VideosData));
				VideosData o;
				if (ValidateId(d.Id)) {
					v = new string[] {d.Id};
				} else if ((v = GetIds(File.ReadAllText(Path.IsPathRooted(d.Id) ? d.Id : Root + Path.DirectorySeparatorChar + d.Id, Encoding.UTF8))) == null || v.Length == 0) {
					goto end;
				}
				do {
					if (!RequestAweme(c, js, "/aweme/v1/multi/aweme/detail/?aweme_ids=[" + v[j] + "]", out r)) {//+ "origin_type="//+ "push_params="
						break;
					}
					o = (VideosData)r;
					if (o != null && o.AwemeDetails != null) {
						for (i = 0; i < o.AwemeDetails.Length; i++, e++) {
							if (e == d.Limit) {
								j = v.Length - 1;
								break;
							} else if (o.AwemeDetails[i].Video != null && (u = GetVideoUrlList(o.AwemeDetails[i].Video)) != null) {
								lock (SyncLock) {
									Count++;
								}
								new Thread(new ParameterizedThreadStart(DownloadAweme)).Start(new Aweme {
									Id = o.AwemeDetails[i].AwemeId,
									Date = o.AwemeDetails[i].CreateTime,
									Description = o.AwemeDetails[i].Desc != null ? o.AwemeDetails[i].Desc : "",
									Url = Quality ? GetQualityUri(u[u.Length - 1]) : u[0],
									AddDate = Date,
									AddDescription = Description
								});
								lock (SyncLock) {
									if (Count >= 10) {
										Monitor.Wait(SyncLock);
									}
								}
							}
						}
					}
					j++;
				} while (j < v.Length);
			} catch (Exception x) {
				lock (OutLock) {
					Output.AppendText(x.Message);
					Output.AppendText(Environment.NewLine);
				}
			}
			do {
				lock (SyncLock) {
					if (Count == 0) {
						break;
					}
					Monitor.Wait(SyncLock);
				}
			} while (true);
			end: EnableControls();
		}
		public void AddDateChanged(object sender, EventArgs args) {
			Date = AddDate.Checked;
		}
		public void AddDescriptionChanged(object sender, EventArgs args) {
			Description = AddDescription.Checked;
		}
		public void ImproveQualityChanged(object sender, EventArgs args) {
			Quality = ImproveQuality.Checked;
		}
		public void PreferHevcChanged(object sender, EventArgs args) {
			Hevc = PreferHevc.Checked;
		}
		public void DirLeave(object sender, EventArgs args) {
			try {
				string d0 = GetFullDir(Dir, Root), d1 = GetFullDir(DirInput.Text, Root);
				if (d0 != d1) {
					if (!Directory.Exists(d1)) {
						Directory.CreateDirectory(d1);
					}
					Directory.SetCurrentDirectory(d1);
					Dir = DirInput.Text;
				}
			} catch (Exception x) {
				MessageBox.Show(x.Message);
				DirInput.Text = Dir;
			}
		}
		public void OpenDirClick(object sender, EventArgs args) {
			if (DirOpener.ShowDialog() != DialogResult.OK) {
				return;
			}
			DirInput.Text = DirOpener.SelectedPath;
			DirLeave(DirInput, null);
		}
		public void TypeSelectedIndexChanged(object sender, EventArgs args) {
			switch (TypeInput.SelectedIndex) {
				case 0:
					IdLabel.Text = "id/name:";
					Tip.SetToolTip(IdInput, "id/name (id or @name) - id or name of a user");
					LimitLabel.Text = "date/max:";
					Tip.SetToolTip(LimitInput, "date/max (optional - YYYY-MM-DD or integer) - date until which to check videos or max number of videos to check");
					CursorInput.ReadOnly = false;
					Tip.SetToolTip(CursorInput, "cursor (integer) - unix time in milliseconds");
					if (OpenFile.Visible) {
						IdInput.Width = IdInput.Width + 26;
						OpenFile.Visible = false;
					}
					break;
				case 1:
					IdLabel.Text = "id/name:";
					Tip.SetToolTip(IdInput, "id/name (id or @name) - id or name of a user");
					LimitLabel.Text = "max:";
					Tip.SetToolTip(LimitInput, "max (optional - integer) - max number of videos to check");
					CursorInput.ReadOnly = false;
					Tip.SetToolTip(CursorInput, "cursor (integer) - unix time in milliseconds");
					if (OpenFile.Visible) {
						IdInput.Width = IdInput.Width + 26;
						OpenFile.Visible = false;
					}
					break;
				case 2:
					IdLabel.Text = "id:";
					Tip.SetToolTip(IdInput, "id - id of a music");
					LimitLabel.Text = "max:";
					Tip.SetToolTip(LimitInput, "max (optional - integer) - max number of videos to check");
					CursorInput.ReadOnly = false;
					Tip.SetToolTip(CursorInput, "cursor (integer) - video offset");
					if (OpenFile.Visible) {
						IdInput.Width = IdInput.Width + 26;
						OpenFile.Visible = false;
					}
					break;
				case 3:
					IdLabel.Text = "id/tag:";
					Tip.SetToolTip(IdInput, "id/tag (id or #tag) - id or tag of a hashtag");
					LimitLabel.Text = "max:";
					Tip.SetToolTip(LimitInput, "max (optional - integer) - max number of videos to check");
					CursorInput.ReadOnly = false;
					Tip.SetToolTip(CursorInput, "cursor (integer) - video offset");
					if (OpenFile.Visible) {
						IdInput.Width = IdInput.Width + 26;
						OpenFile.Visible = false;
					}
					break;
				default://4
					IdLabel.Text = "id/file:";
					Tip.SetToolTip(IdInput, "id/file (id or file) - id of a video or file with ids or urls of videos (separated by whitespace)");
					LimitLabel.Text = "max:";
					Tip.SetToolTip(LimitInput, "max (optional - integer) - max number of videos to check");
					CursorInput.ReadOnly = true;
					Tip.SetToolTip(CursorInput, "cursor (integer)");
					if (!OpenFile.Visible) {
						IdInput.Width = IdInput.Width - 26;
						OpenFile.Visible = true;
					}
					break;
			}
		}
		public void OpenFileClick(object sender, EventArgs args) {
			if (TypeInput.SelectedIndex != 4 || FileOpener.ShowDialog() != DialogResult.OK) {
				return;
			}
			IdInput.Text = FileOpener.FileName;
		}
		public void InfoClick(object sender, EventArgs args) {
			lock (StopLock) {
				Stop = true;
				if (IdInput.ReadOnly) {
					return;
				}
			}
			DisableControls();
			switch (TypeInput.SelectedIndex) {
				case 0:
				case 1:
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id or name is empty.");
						goto end;
					} else if (IdInput.Text[0] == '@') {
						if (IdInput.Text.Length == 1) {
							MessageBox.Show("Name is empty.");
							goto end;
						}
					} else if (!ValidateId(IdInput.Text)) {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(InfoUser)).Start(IdInput.Text);
					return;
				case 2:
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id is empty.");
						goto end;
					} else if (!ValidateId(IdInput.Text)) {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(InfoMusic)).Start(IdInput.Text);
					return;
				case 3:
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id or tag is empty.");
						goto end;
					} else if (IdInput.Text[0] == '#') {
						if (IdInput.Text.Length == 1) {
							MessageBox.Show("Tag is empty.");
							goto end;
						}
					} else if (!ValidateId(IdInput.Text)) {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(InfoChallenge)).Start(IdInput.Text);
					return;
				default://4
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id is empty.");
						goto end;
					} else if (!ValidateId(IdInput.Text)) {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(InfoVideo)).Start(IdInput.Text);
					return;
			}
			end: EnableControls();
		}
		public void DownloadClick(object sender, EventArgs args) {
			lock (StopLock) {
				Stop = true;
				if (IdInput.ReadOnly) {
					return;
				}
			}
			DisableControls();
			if (Log.Checked) {
				try {
					Logger = new FileStream("log.txt", FileMode.Append);
				} catch (Exception x) {
					MessageBox.Show(x.Message);
					goto end;
				}
			}
			long l, c;
			switch (TypeInput.SelectedIndex) {
				case 0:
				case 1:
					bool im;
					DateTime d;
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id or name is empty.");
						goto end;
					} else if (IdInput.Text[0] == '@') {
						if (IdInput.Text.Length == 1) {
							MessageBox.Show("Name is empty.");
							goto end;
						} else if (LimitInput.Text.Length == 0) {
							im = true;
							l = -1;
						} else if (TypeInput.SelectedIndex == 0 && DateTime.TryParseExact(LimitInput.Text, "yyyy-MM-dd", CultureInfo.InvariantCulture, DateTimeStyles.None, out d)) {
							im = false;
							l = (long)d.Subtract(new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).TotalSeconds;
						} else if (Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
							im = true;
						} else {
							MessageBox.Show(TypeInput.SelectedIndex == 0 ? "Date or max is not valid." : "Max is not valid.");
							goto end;
						}
					} else if (ValidateId(IdInput.Text)) {
						if (LimitInput.Text.Length == 0) {
							im = true;
							l = -1;
						} else if (TypeInput.SelectedIndex == 0 && DateTime.TryParseExact(LimitInput.Text, "yyyy-MM-dd", CultureInfo.InvariantCulture, DateTimeStyles.None, out d)) {
							im = false;
							l = (long)d.Subtract(new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).TotalSeconds;
						} else if (Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
							im = true;
						} else {
							MessageBox.Show(TypeInput.SelectedIndex == 0 ? "Date or max is not valid." : "Max is not valid.");
							goto end;
						}
					} else {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					if (!Int64.TryParse(CursorInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out c)) {
						MessageBox.Show("Cursor is not valid integer.");
						goto end;
					}
					Output.Text = "";
					new Thread(TypeInput.SelectedIndex == 0 ? new ParameterizedThreadStart(DownloadUserVideos) : new ParameterizedThreadStart(DownloadUserFavorites)).Start(new Download {
						Id = IdInput.Text,
						Limit = l,
						IsMax = im,
						Cursor = c
					});
					return;
				case 2:
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id is empty.");
						goto end;
					} else if (ValidateId(IdInput.Text)) {
						if (LimitInput.Text.Length == 0) {
							l = -1;
						} else if (!Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
							MessageBox.Show("Max is not valid.");
							goto end;
						}
					} else {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					if (!Int64.TryParse(CursorInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out c)) {
						MessageBox.Show("Cursor is not valid integer.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(DownloadMusicVideos)).Start(new Download {
						Id = IdInput.Text,
						Limit = l,
						IsMax = true,
						Cursor = c
					});
					return;
				case 3:
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id or tag is empty.");
						goto end;
					} else if (IdInput.Text[0] == '#') {
						if (IdInput.Text.Length == 1) {
							MessageBox.Show("Tag is empty.");
							goto end;
						} else if (LimitInput.Text.Length == 0) {
							l = -1;
						} else if (!Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
							MessageBox.Show("Max is not valid.");
							goto end;
						}
					} else if (ValidateId(IdInput.Text)) {
						if (LimitInput.Text.Length == 0) {
							l = -1;
						} else if (!Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
							MessageBox.Show("Max is not valid.");
							goto end;
						}
					} else {
						MessageBox.Show("Id is not valid.");
						goto end;
					}
					if (!Int64.TryParse(CursorInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out c)) {
						MessageBox.Show("Cursor is not valid integer.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(DownloadChallengeVideos)).Start(new Download {
						Id = IdInput.Text,
						Limit = l,
						IsMax = true,
						Cursor = c
					});
					return;
				default://4
					if (IdInput.Text.Length == 0) {
						MessageBox.Show("Id is empty.");
						goto end;
					} else if (LimitInput.Text.Length == 0) {
						l = -1;
					} else if (!Int64.TryParse(LimitInput.Text, NumberStyles.None, CultureInfo.InvariantCulture, out l)) {
						MessageBox.Show("Max is not valid.");
						goto end;
					}
					Output.Text = "";
					new Thread(new ParameterizedThreadStart(DownloadVideos)).Start(new Download {
						Id = IdInput.Text,
						Limit = l,
						IsMax = true,
						Cursor = 0
					});
					return;
			}
			end: EnableControls();
		}
		/*public static bool ValidateRemoteCertificate(object sender, object certificate, object chain, SslPolicyErrors sslPolicyErrors) {
			return true;
		}*/
		[STAThread]
		public static void Main() {
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);
			ServicePointManager.SecurityProtocol |= SecurityProtocolType.Ssl3 | SecurityProtocolType.Tls | SecurityProtocolType.Tls11 | SecurityProtocolType.Tls12 | SecurityProtocolType.Tls13;//.NET 4.8
			//ServicePointManager.ServerCertificateValidationCallback += ValidateRemoteCertificate;//.NET 3.5
			string d = Path.GetDirectoryName(Environment.GetCommandLineArgs()[0]);
			d += d.Length > 0 ? Path.DirectorySeparatorChar + "download" : "download";
			try {
				if (!Directory.Exists(d)) {
					Directory.CreateDirectory(d);
				}
				Directory.SetCurrentDirectory(d);
			} catch {
				MessageBox.Show("Could not initialize download directory.");
				return;
			}
			Application.Run(new MainForm(Path.GetDirectoryName(d), Path.GetFileName(d)));
		}
	}
}