var os = require("os"),
fs = require("fs"),
path = require("path"),
url = require("url"),
http = require("http"),
https = require("https"),
child_process = require("child_process"),
puppeteer = require("puppeteer-extra"),//puppeteer
stealth = require("puppeteer-extra-plugin-stealth"),
browser = null,
page = null,
userAgent = null,
cookie = generateCookie(),
help = "node " + path.basename(__filename) + " t=ui|mi|hi|vi|uv|ul|mv|hv|v i=0|@name|#tag|file.txt [l=" + (new Date(0)).toISOString().substring(0, 10) + "|-1] [o=0] [c] [d] [q] [h] [g] [f] [\"j=" + cookie + "\"]"
+ os.EOL + "t - ui (user info), mi (music info), hi (hashtag info), vi (video info),"
+ os.EOL + "    uv (user videos), ul (user likes), mv (music videos), hv (hashtag videos) or v (videos)"
+ os.EOL + "i - id or @name of a user, id of a music, id or #tag of a hashtag,"
+ os.EOL + "    id of a video or file (empty value for stdin) with ids or urls of videos (separated by whitespace)"
+ os.EOL + "l - date until which to check videos (YYYY-MM-DD)"
+ os.EOL + "    or max number of videos to check (integer)"
+ os.EOL + "o - cursor (integer) - unix time in milliseconds (user videos and likes) or video offset (music and hashtag videos)"
+ os.EOL + "c - add date"
+ os.EOL + "d - add description"
+ os.EOL + "q - improve quality"
+ os.EOL + "h - prefer HEVC/H.265"
+ os.EOL + "g - log"
+ os.EOL + "f - directory"
+ os.EOL + "j - cookie http request header value of https://www.tiktok.com/"
+ os.EOL + "node " + path.basename(__filename) + " e=file.txt [r=-1] [p=1] [o]"
+ os.EOL + "e - file (empty value for stdin) with commands (separated by newline,"
+ os.EOL + "    separate arguments with space,"
+ os.EOL + "    escape arguments with quotation marks or apostrophes"
+ os.EOL + "    and quotation marks and apostrophes by doubling)"
+ os.EOL + "r - repeat interval in seconds"
+ os.EOL + "p - max concurrent processes"
+ os.EOL + "o - redirect output to stdout and stderr",
limit = -1,
cursor = 0,
max = true,
date = false,
description = false,
quality = false,
hevc = false,
logger = null,
directory = __dirname + path.sep + "download",
running = true,
timeout = null,
idRegex = /^[1-9][0-9]{0,19}$/,
deviceId = generateDeviceId(),
iId = generateDeviceId(),
deviceVersion = generateBase62(8);
function deferOpenBrowser() {
	puppeteer.use(stealth());
	return puppeteer.launch({
		headless: true,
		ignoreHTTPSErrors: true,
		handleSIGINT: false
	}).then(function(value) {
		return (browser = value).newPage();
	}).then(function(value) {
		return (page = value).goto("https://www.tiktok.com/legal/terms-of-use");
	}).then(function(value) {
		return page.evaluate(function() {
			return new Promise(function(resolve, reject) {
				if (window.byted_acrawler) {
					resolve(null);
					return;
				}
				var s = document.createElement("script");
				s.type = "text/javascript";
				s.src = "https://sf-tb-sg.ibytedtos.com/obj/rc-web-sdk-sg/acrawler.js";
				s.onload = function() {
					window.byted_acrawler.init({
						aid: 1988,
						dfp: false,
						boe: false,
						intercept: false,
						enablePathList: ["/api/user/detail/", "/api/user/list/", "/api/music/detail/", "/api/item/detail/", "/api/challenge/detail/", "/share/item/list", "/api/item_list/", "/api/music/item_list/", "/api/challenge/item_list/", "/api/recommend/item_list/", "/api/recommend/embed_videos/", "/api/comment/list/", "/api/comment/list/reply/", "/api/discover/challenge/", "/api/discover/music/", "/api/discover/user/", "/api/commit/follow/user/", "/api/recommend/user/", "/api/impression/write/", "/share/item/explore/list", "/api/commit/item/digg/", "/node/share/discover", "/discover/render/undefined", "/node/feedback/upload_image/", "/aweme/v1/upload/image2/", "/api/notice/multi/", "/api/notice/count/", "/api/notice/digg/list/", "/api/user/following/request/list/", "/api/commit/follow/request/approve/", "/api/commit/follow/request/reject/", "/api/comment/digg/", "/api/comment/publish/", "/api/comment/delete/", "/api/user/contact/list/", "/api/at/default/list/", "/api/comment/search/user/"]
					});
					resolve(null);
				};
				s.onerror = function() {
					reject(null);
				};
				document.body.appendChild(s);
			});
		});
	}).then(function(value) {
		return page.evaluate("navigator.userAgent")
	}).then(function(value) {
		userAgent = value;
	});
}
function deferCloseBrowser() {
	if (browser !== null) {
		return browser.close().then(function(value) {
			browser = page = userAgent = null;
		}, function(error) {
			console.error(error);
		});
	}
	return Promise.resolve();
}
function generateSign(url) {
	return window.byted_acrawler.sign({url: encodeURI(url)});
}
function deferSignUrl(url) {
	if (page === null) {
		return Promise.reject(new Error("Could not generate signature."));
	}
	return page.evaluate(generateSign, url).then(function(value) {
		return url + "&_signature=" + value;
	});
}
function generateBase62(length) {
	var i = 0, r = "", base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	while (i < length) {
		r += base62.charAt(Math.floor(Math.random() * 62));
		i++;
	}
	return r;
}
function generateDeviceId() {
	var i = 1, a = new Array(19);//Math.floor(Math.random() * 9) + 11
	a[0] = 54;//Math.floor(Math.random() * 9) + 49
	while (i < a.length) {
		a[i++] = Math.floor(Math.random() * 10) + 48;
	}
	return String.fromCharCode.apply(null, a);
}
function generateVerify() {
	var i = 0, d = new Date(), t = d.getTime() - d.getTimezoneOffset() * 60000, r = "", base62 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	do {
		switch (i) {
			case 8:
			case 13:
			case 18:
			case 23:
				r += "_";
				break;
			case 14:
				r += "4";
				break;
			default:
				r += base62.charAt(Math.floor(Math.random() * 62));
				break;
		}
		i++;
	} while (i < 36);
	return "verify_" + t.toString(36) + "_" + r;
}
function generateCookie() {
	var t = generateDeviceId();
	return "tt_webid=" + t + "; tt_webid_v2=" + t + "; tt_csrf_token=" + generateBase62(24) + "; s_v_web_id=" + generateVerify();
}
function getQualityUri(value) {
	var i = value.indexOf("?video_id="), e;
	if (i > -1 && (e = value.indexOf("&", i + 10)) > -1) {
		return "https://api.tiktokv.com/aweme/v1/play/" + value.substring(i, e) + "&improve_bitrate=1&ratio=default";
	}
	return value;
}
function getQualityUri_(value) {
	var i = value.indexOf("?video_id="), e;
	if (i > -1 && (e = value.indexOf("&", i + 10)) > -1) {
		return "https://api-h2.tiktokv.com/aweme/v1/play/" + value.substring(i, e) + "&improve_bitrate=1&ratio=default";
	}
	return value;
}
function createTimeToString(value) {
	var t = (new Date(value * 1000)).toISOString();
	return t.length === 24 ? t.substring(0, 10) + " " + t.substring(11, 19) : t.substring(0, 13) + " " + t.substring(14, 22);
}
function createTimeToFilename(value) {
	var t = (new Date(value * 1000)).toISOString();
	return t.substring(0, t.length === 24 ? 19 : 22).replace(/[-:]/g, "") + "Z";
}
function createTimeToLog(value) {
	var t = (new Date(value * 1000)).toISOString();
	return (t.length === 24 ? t.substring(0, 19) : t.substring(0, 22)) + "Z";
}
function sanitizeFilename(value) {
	return value.replace(/[\x00-\x1f"*/:<>?\\|]/g, "");
}
function sanitizeLog(value) {
	return value.replace(/[\r\n]/g, "");
}
function ensureDirectorySync(directory) {
	if ((directory = path.normalize(directory)).lastIndexOf(path.sep) + path.sep.length >= directory.length) {
		directory = directory.substring(0, directory.length - path.sep.length);
	}
	try {
		if (!fs.lstatSync(directory).isDirectory()) {
			throw new Error("Path is not a directory.");
		}
	} catch (e) {
		if (e.code !== "ENOENT") {
			throw e;
		}
		for (var i = directory.length + path.sep.length, e, t; (i -= path.sep.length) > -1
		&& (i = directory.lastIndexOf(path.sep, i)) > -1
		&& !fs.existsSync(t = directory.substring(0, i));) {}
		if (i > -1) {
			i += path.sep.length;
			e = t.length;
		} else if (directory.substring(0, path.sep.length) === path.sep) {
			t = "";
			i = path.sep.length;
			e = 0;
		} else {//root
			t = "." + path.sep;
			i = 0;
			e = 0;
		}
		for (; (i = directory.indexOf(path.sep, i)) > -1; e = i, i += path.sep.length) {
			fs.mkdirSync(t += directory.substring(e, i));
		}
		fs.mkdirSync(t + directory.substring(e));
	}
}
function emptyFunction() {}
function parseArgv(arguments) {
	var i = 2, e, r = {};
	while (i < arguments.length) {
		e = arguments[i].indexOf("=");
		if (e === -1) {
			r[arguments[i]] = "";
		} else {
			r[arguments[i].substring(0, e)] = arguments[i].substring(e + 1);	
		}
		i++;
	}
	return r;
}
function readStdIn(callback) {
	var d = "", s = process.stdin.isTTY ? fs.createReadStream(null, {fd: process.stdin.fd}) : process.stdin;
	s.setEncoding("utf8");
	s.on("data", function(data) {
		d += data;
	}).on("error", function(error) {
		if (callback !== null) {
			callback(error);
			callback = null;
		}
	}).on("end", function() {
		if (callback !== null) {
			callback(null, d);
			callback = null;
		}
	});
	s.resume();
}
function getCmds(value) {
	var i = 0, lr = /(?:\r\n|[\r\n])+/g, m, r = [];
	while ((m = lr.exec(value)) !== null) {
		if (i < lr.lastIndex - m[0].length) {
			r.push(value.substring(i, lr.lastIndex - m[0].length));
		}
		i = lr.lastIndex;
	}
	if (i < value.length) {
		r.push(value.substring(i));
	}
	return r;
}
function splitCmd(value, args) {
	args = args || [];
	for (var i = 0, e, c, t, sr = /[^ ]/g; i < value.length;) {
		switch (value.charCodeAt(i)) {
			case 32:
				sr.lastIndex = i + 1;
				i = (t = sr.exec(value)) !== null ? t.index : value.length;
				break;
			case 34:
				for (i++, e = 0, t = []; i < value.length; i++) {
					if ((c = value.charCodeAt(i)) === 34 && (++i === value.length || value.charCodeAt(i) !== 34)) {
						e = 1;
						break;
					}
					t.push(c);
				}
				if (e === 0) {
					throw new Error("Unescaped quotation mark detected.");
				}
				args.push(String.fromCharCode.apply(null, t));
				break;
			case 39:
				for (i++, e = 0, t = []; i < value.length; i++) {
					if ((c = value.charCodeAt(i)) === 39 && (++i === value.length || value.charCodeAt(i) !== 39)) {
						e = 1;
						break;
					}
					t.push(c);
				}
				if (e === 0) {
					throw new Error("Unescaped apostrophe detected.");
				}
				args.push(String.fromCharCode.apply(null, t));
				break;
			default:
				args.push(value.substring(i, (i = value.indexOf(" ", i + 1)) > -1 ? i : i = value.length));
				break;
		}
	}
	return args;
}
function requestGet(uri, headers, callback) {
	try {
		var u = typeof uri === "string" ? new url.URL(uri) : uri, h, r;
		if (u.protocol === "http:") {
			h = http;
		} else if (u.protocol === "https:") {
			h = https;
		} else {
			process.nextTick(callback, new Error("Only http and https is supported."));
			return;
		}
		r = h.request({
			method: "GET",
			host: u.host,
			port: +u.port || 0,
			path: u.pathname + u.search,//+ u.hash
			headers: headers
		}, function(response) {
			if (callback === null) {
				return;
			} else if (response.statusCode >= 300 && response.statusCode < 400) {
				var l = response.headers["location"];
				if (l === undefined) {
					callback(new Error("Redirection without location."));
					callback = null;
				} else {
					try {
						requestGet(new URL(l, String(uri)), headers, callback);
					} catch (e) {
						callback(e);
						callback = null;
					}
				}
				return;
			} else if (response.statusCode !== 200) {
				callback(new Error(response.statusMessage));
				callback = null;
				return;
			}
			callback(null, response, r, String(uri));
			callback = null;
		}).on("error", function(error) {
			if (callback === null) {
				return;
			}
			callback(error);
			callback = null;
		}).end();
	} catch (e) {
		process.nextTick(callback, e);
		return;
	}
}
function requestGetJson(uri, headers, callback) {
	requestGet(uri, headers, function(error, response, request) {
		if (error !== null) {
			callback(error);
			return;
		}
		var d = "";
		response.setEncoding("utf8");
		response.on("data", function(data) {
			d += data;
		}).on("error", function(error) {
			if (callback === null) {
				return;
			}
			callback(error);
			callback = null;
		}).on("end", function() {
			if (callback === null) {
				return;
			}
			try {
				callback(null, JSON.parse(d));
			} catch (e) {
				callback(e);
			}
			callback = null;
		});
	});
}
function requestGetBuffer(uri, headers, callback) {
	requestGet(uri, headers, function(error, response, request) {
		if (error !== null) {
			callback(error);
			return;
		}
		var d = [];
		//response.setEncoding("binary");
		response.on("data", function(data) {
			d.push(data);
		}).on("error", function(error) {
			if (callback === null) {
				return;
			}
			callback(error);
			callback = null;
		}).on("end", function() {
			if (callback === null) {
				return;
			}
			try {
				callback(null, Buffer.concat(d));
			} catch (e) {
				callback(e);
			}
			callback = null;
		});
	});
}
function getIds(value, callback) {
	var i = 0, wr = /\s+/g, ur = /\/([1-9][0-9]{0,19})/, r = [], f0 = function() {
		var m, t;
		while ((m = wr.exec(value)) !== null) {
			if (i < wr.lastIndex - m[0].length) {
				if (idRegex.test(t = value.substring(i, wr.lastIndex - m[0].length))) {
					r.push(t);
				} else if ((m = t.match(ur)) !== null) {
					r.push(m[1]);
				} else {
					i = wr.lastIndex;
					f1(t, false);
					return;
				}
			}
			i = wr.lastIndex;
		}
		if (i < value.length) {
			if (idRegex.test(t = value.substring(i))) {
				r.push(t);
			} else if ((m = t.match(ur)) !== null) {
				r.push(m[1]);
			} else {
				f1(t, true);
				return;
			}
		}
		callback(null, r);
	}, f1 = function(uri, last) {
		requestGet(uri, {"User-Agent": "Mozilla/5.0 AppleWebKit/537.36 Chrome/87.0.4280.88 Safari/537.36"}, function(error, response, request) {
			var m;
			if (error === null && (m = request.path.match(ur)) !== null) {
				r.push(m[1]);
			}
			if (last) {
				callback(null, r);
			} else {
				f0();
			}
		});
	};
	process.nextTick(f0);
}
function getVideoUrlList(value) {
	if (hevc) {
		if (typeof value.play_addr_265 === "object" && value.play_addr_265 !== null
		&& typeof value.play_addr_265.url_list === "object" && value.play_addr_265.url_list !== null && value.play_addr_265.url_list.length > 0) {
			return value.play_addr_265.url_list;
		} else if (typeof value.play_addr_bytevc1 === "object" && value.play_addr_bytevc1 !== null
		&& typeof value.play_addr_bytevc1.url_list === "object" && value.play_addr_bytevc1.url_list !== null && value.play_addr_bytevc1.url_list.length > 0) {
			return value.play_addr_bytevc1.url_list;
		}
	}
	if (typeof value.play_addr === "object" && value.play_addr !== null
	&& typeof value.play_addr.url_list === "object" && value.play_addr.url_list !== null && value.play_addr.url_list.length > 0) {
		return value.play_addr.url_list;
	}
	return null;
}
function downloadAweme(filename, uri, callback) {
	var f = function(error, repeat) {
		if (repeat > 3) {
			callback(error);
			return;
		}
		requestGet(uri, {"User-Agent": "okhttp"}, function(error, response, request) {
			if (error !== null) {
				f(error, repeat + 1);
				return;
			} else if (+response.headers["content-length"] === 0) {
				f(new Error("Response body is empty."), repeat + 1);
				return;
			}
			response.pipe(fs.createWriteStream(filename, {emitClose: true}).on("error", function(error) {
				if (callback === null) {
					return;
				}
				var f = callback;
				callback = null;
				fs.unlink(filename, function(error_) {
					f(error);
				});
			}).on("close", function() {
				if (callback === null) {
					return;
				}
				var ff = callback;
				callback = null;
				fs.stat(filename, function(error, stats) {
					if (error !== null) {
						f(error, repeat + 1);
						return;
					} else if (stats.size === 0) {
						fs.unlink(filename, function(error) {
							f(new Error("File is empty."), repeat + 1);
						});
						return;
					}
					ff(null);
				});
			}));
		});
	};
	f(null, 0);
}
function ensureAweme(video, callback) {
	var d = date && video.time > 0 ? createTimeToFilename(video.time) : "", t = description && video.desc.length > 0 ? sanitizeFilename(video.desc) : "", n = (d.length > 0 ? video.id + " " + d : video.id) + (t.length > 0 ? " " + t + ".mp4" : ".mp4");
	fs.access(n, function(error) {
		if (error !== null) {
			if (error.code !== "ENOENT") {
				callback(error);
				return;
			}
			var f = function() {
				downloadAweme(n, video.uri, function(error) {
					if (error !== null) {
						callback(error);
					} else {
						callback(null, false);
					}
				});
			};
			if (t.length > 0) {
				fs.open(n, "w", function(error, fd) {
					if (error !== null) {
						t = "";
						fs.access(n = (d.length > 0 ? video.id + " " + d : video.id) + ".mp4", function(error) {
							if (error !== null) {
								if (error.code !== "ENOENT") {
									callback(error);
									return;
								}
								f();
							} else {
								callback(null, true);
							}
						});
						return;
					}
					fs.close(fd, function(error) {
						fs.unlink(n, f);
					});
				});
			} else {
				f();
			}
		} else {
			callback(null, true);
		}
	});
}
/*function downloadAwemes(videos, callback) {
	var i = 0, e = 0, f0 = function() {
		if (running) {
			while (i < videos.length && e < 10) {
				f1(videos[i]);
				e++;
				i++;
			}
		}
		if (e === 0 && (!running || i === videos.length)) {
			callback(null);
		}
	}, f1 = function(video) {
		ensureAweme(video, function(error, exists) {
			if (error !== null) {
				console.log(video.id + " failed");
				console.error(error);
			} else if (!exists) {
				console.log(video.id + " is downloaded");
				if (logger !== null) {
					try {
						fs.writeSync(logger, video.id + " " + createTimeToLog(video.time) + " " + sanitizeLog(video.desc) + os.EOL);
					} catch (e) {}
				}
			}
			e--;
			f0();
		});
	};
	f0();
}*/
function requestTiktok(path, callback) {
	var t = cookie, f = function(error, repeat) {
		if (repeat > 9 || (!running && error !== null)) {
			callback(error);
			return;
		}
		deferSignUrl("https://m.tiktok.com" + path + "&aid=1988&appId=1233&appType=m&app_name=tiktok_web&device_platform=web&language=en").then(function(value) {
			requestGetJson(value, {
				"User-Agent": userAgent,
				"Referer": "https://www.tiktok.com/",
				"Cookie": cookie
			}, function(error, data) {
				if (error !== null) {
					//t = cookie = generateCookie();
					f(error, repeat + 1);
					return;
				} else if (typeof data !== "object" || data === null || typeof data.statusCode !== "number") {//required
					//t = cookie = generateCookie();
					f(new Error("Unexpected response."), repeat + 1);
					return;
				}
				callback(null, data, t);
			});
		}, function(error) {
			//t = cookie = generateCookie();
			f(error, repeat + 1);
		});
	};
	f(null, 0);//setTimeout(f, 1000, null, 0);
}
function requestAweme(path, callback) {
	var f = function(error, repeat) {
		if (repeat > 32 || (!running && error !== null)) {
			callback(error);
			return;
		}
		var d = new Date(), t = d.getTime() - d.getTimezoneOffset() * 60000;
		requestGetJson("https://api-t2.tiktokv.com" + path
		+ "&region=US"
		//+ "&version_name=10.0.0"
		+ "&ts=" + Math.floor(t / 1000)
		+ "&timezone_name=Etc%2FGMT"
		+ "&device_type=Pixel%20" + deviceVersion
		+ "&iid=" + iId
		+ "&locale=en"
		+ "&app_type=normal"
		//+ "&build_number=10.0.0"
		+ "&resolution=1080*1920"
		+ "&aid=1180"
		+ "&app_name=musical_ly"
		+ "&_rticket=" + t
		+ "&device_platform=android"
		+ "&version_code=100000"
		+ "&dpi=441"
		+ "&cpu_support64=false"
		+ "&sys_region=US"
		+ "&timezone_offset=0"
		+ "&device_id=" + deviceId
		+ "&pass-route=1"
		+ "&device_brand=google"
		+ "&os_version=8.0.0"
		//+ "&ab_version=10.0.0"
		+ "&op_region=US"
		+ "&app_language=en"
		+ "&pass-region=1"
		+ "&language=en"
		+ "&channel=googleplay"
		+ (hevc ? "&version_name=10.0.0&build_number=10.0.0" : ""), {"User-Agent": "okhttp"}, function(error, data) {
			if (error !== null) {
				deviceId = generateDeviceId();
				iId = generateDeviceId();
				deviceVersion = generateBase62(8);
				f(error, repeat + 1);
				return;
			}
			callback(null, data);
		});
	};
	setTimeout(f, 1000, null, 0);//f(null, 0);
}
//*remove {
function requestTiktok_(path, callback) {
	var t = cookie, f = function(error, repeat) {
		if (repeat > 9 || (!running && error !== null)) {
			callback(error);
			return;
		}
		requestGetJson("https://www.tiktok.com" + path, {
			"User-Agent": "Mozilla/5.0 AppleWebKit/537.36 Chrome/87.0.4280.88 Safari/537.36",
			"Referer": "https://www.tiktok.com/",
			"Cookie": cookie
		}, function(error, data) {
			if (error !== null) {
				//t = cookie = generateCookie();
				f(error, repeat + 1);
				return;
			} else if (typeof data !== "object" || data === null || typeof data.statusCode !== "number") {//required
				//t = cookie = generateCookie();
				f(new Error("Unexpected response."), repeat + 1);
				return;
			}
			callback(null, data, t);
		});
	};
	f(null, 0);//setTimeout(f, 1000, null, 0);
}
function getUser(id, callback) {
	requestGet("https://www.tiktok.com/share/user/" + id, {"User-Agent": "Mozilla/5.0 AppleWebKit/537.36 Chrome/87.0.4280.88 Safari/537.36"}, function(error, response, request) {
		if (error !== null) {
			callback(error);
			return;
		}
		var m = request.path.match(/@([^?/]+)/);
		if (m === null) {
			callback(new Error("Could not find the user."));
		} else {
			callback(null, decodeURI(m[1]));
		}
	});
}
function infoUser(idOrName, callback) {
	var f = function(error, data) {
		if (error !== null) {
			console.error(error);
		} else if (typeof data !== "object" || data === null
		|| typeof data.userInfo !== "object" || data.userInfo === null
		|| typeof data.userInfo.user !== "object" || typeof data.userInfo.user === null
		|| typeof data.userInfo.stats !== "object" || typeof data.userInfo.stats === null) {
			console.error(new Error("Unexpected response."));
		} else {
			console.log("id: " + data.userInfo.user.id);
			console.log("unique id: " + data.userInfo.user.uniqueId);
			console.log("secure id: " + data.userInfo.user.secUid);
			console.log("nickname: " + data.userInfo.user.nickname);
			if (typeof data.userInfo.user.createTime === "number" && data.userInfo.user.createTime !== 0) {
				console.log("created: " + createTimeToString(data.userInfo.user.createTime));
			}
			console.log("verified: " + data.userInfo.user.verified);
			console.log("private: " + data.userInfo.user.secret);
			console.log("likes: " + data.userInfo.user.openFavorite);
			console.log("videos: " + data.userInfo.stats.videoCount);
			console.log("favorites: " + data.userInfo.stats.diggCount);
			console.log("favorited: " + data.userInfo.stats.heartCount);
			console.log("followings: " + data.userInfo.stats.followingCount);
			console.log("followers: " + data.userInfo.stats.followerCount);
			if (typeof data.userInfo.user.avatarLarger === "string" && data.userInfo.user.avatarLarger.length > 0) {
				console.log("avatar: " + data.userInfo.user.avatarLarger);
			}
			if (typeof data.userInfo.user.signature === "string" && data.userInfo.user.signature.length > 0) {
				console.log(data.userInfo.user.signature);
			}
			if (typeof data.userInfo.user.bioLink === "object" && data.userInfo.user.bioLink !== null
			&& typeof data.userInfo.user.bioLink.link === "string" && data.userInfo.user.bioLink.link.length > 0) {
				console.log(data.userInfo.user.bioLink.link);
			}
		}
		callback(null);
	};
	if (idOrName.charCodeAt(0) === 64) {
		requestTiktok_("/node/share/user/@" + encodeURI(idOrName.substring(1)) + "?user_agent=", f);
	} else {
		getUser(idOrName, function(error, name) {
			if (error !== null) {
				console.log(error);
				callback(null);
				return;
			}
			requestTiktok_("/node/share/user/@" + encodeURI(name) + "?user_agent=", f);
		});
	}
}
//}
/*function infoUser(idOrName, callback) {
	requestTiktok("/api/user/detail/?" + (idOrName.charCodeAt(0) === 64 ? "uniqueId=" + encodeURIComponent(idOrName.substring(1)) : "userId=" + idOrName), function(error, data) {
		if (error !== null) {
			console.error(error);
		} else if (typeof data !== "object" || data === null
		|| typeof data.userInfo !== "object" || data.userInfo === null
		|| typeof data.userInfo.user !== "object" || typeof data.userInfo.user === null
		|| typeof data.userInfo.stats !== "object" || typeof data.userInfo.stats === null) {
			console.error(new Error("Unexpected response."));
		} else {
			console.log("id: " + data.userInfo.user.id);
			console.log("unique id: " + data.userInfo.user.uniqueId);
			console.log("secure id: " + data.userInfo.user.secUid);
			console.log("nickname: " + data.userInfo.user.nickname);
			console.log("verified: " + data.userInfo.user.verified);
			console.log("private: " + data.userInfo.user.secret);
			console.log("likes: " + data.userInfo.user.openFavorite);
			console.log("videos: " + data.userInfo.stats.videoCount);
			console.log("favorites: " + data.userInfo.stats.diggCount);
			console.log("favorited: " + data.userInfo.stats.heartCount);
			console.log("followings: " + data.userInfo.stats.followingCount);
			console.log("followers: " + data.userInfo.stats.followerCount);
			if (typeof data.userInfo.user.avatarLarger === "string" && data.userInfo.user.avatarLarger.length > 0) {
				console.log("avatar: " + data.userInfo.user.avatarLarger);
			}
			if (typeof data.userInfo.user.signature === "string" && data.userInfo.user.signature.length > 0) {
				console.log(data.userInfo.user.signature);
			}
			if (typeof data.userInfo.user.bioLink === "object" && data.userInfo.user.bioLink !== null
			&& typeof data.userInfo.user.bioLink.link === "string" && data.userInfo.user.bioLink.link.length > 0) {
				console.log(data.userInfo.user.bioLink.link);
			}
		}
		callback(null);
	});
}*/
function infoMusic(id, callback) {
	requestTiktok("/api/music/detail/?musicId=" + id, function(error, data) {
		if (error !== null) {
			console.error(error);
		} else if (typeof data !== "object" || data === null
		|| typeof data.musicInfo !== "object" || data.musicInfo === null
		|| typeof data.musicInfo.music !== "object" || typeof data.musicInfo.music === null
		|| typeof data.musicInfo.stats !== "object" || typeof data.musicInfo.stats === null) {
			console.error(new Error("Unexpected response."));
		} else {
			console.log("id: " + data.musicInfo.music.id);
			console.log("title: " + data.musicInfo.music.title);
			if (typeof data.musicInfo.music.authorName === "string" && data.musicInfo.music.authorName.length > 0) {
				console.log("author: " + data.musicInfo.music.authorName);
			}
			console.log("videos: " + data.musicInfo.stats.videoCount);
			if (typeof data.musicInfo.music.coverLarge === "string" && data.musicInfo.music.coverLarge.length > 0) {
				console.log("cover: " + data.musicInfo.music.coverLarge);
			}
			if (typeof data.musicInfo.music.playUrl === "string" && data.musicInfo.music.playUrl.length > 0) {
				console.log("play: " + data.musicInfo.music.playUrl);
			}
			if (typeof data.musicInfo.author === "object" && typeof data.musicInfo.author !== null) {
				console.log("user id: " + data.musicInfo.author.id);
				console.log("user unique id: " + data.musicInfo.author.uniqueId);
				console.log("user secure id: " + data.musicInfo.author.secUid);
				console.log("user nickname: " + data.musicInfo.author.nickname);
				console.log("user verified: " + data.musicInfo.author.verified);
				console.log("user private: " + data.musicInfo.author.secret);
				console.log("user likes: " + data.musicInfo.author.openFavorite);
				if (typeof data.musicInfo.author.avatarLarger === "string" && data.musicInfo.author.avatarLarger.length > 0) {
					console.log("user avatar: " + data.musicInfo.author.avatarLarger);
				}
				if (typeof data.musicInfo.author.signature === "string" && data.musicInfo.author.signature.length > 0) {
					console.log(data.musicInfo.author.signature);
				}
			}
		}
		callback(null);
	});
}
function infoHashtag(idOrTag, callback) {
	requestTiktok("/api/challenge/detail/?" + (idOrTag.charCodeAt(0) === 35 ? "challengeName=" + encodeURIComponent(idOrTag.substring(1)) : "challengeId=" + idOrTag), function(error, data) {
		if (error !== null) {
			console.error(error);
		} else if (typeof data !== "object" || data === null
		|| typeof data.challengeInfo !== "object" || data.challengeInfo === null
		|| typeof data.challengeInfo.challenge !== "object" || typeof data.challengeInfo.challenge === null
		|| typeof data.challengeInfo.stats !== "object" || typeof data.challengeInfo.stats === null) {
			console.error(new Error("Unexpected response."));
		} else {
			console.log("id: " + data.challengeInfo.challenge.id);
			console.log("tag: " + data.challengeInfo.challenge.title);
			console.log("videos: " + data.challengeInfo.stats.videoCount);
			console.log("views: " + data.challengeInfo.stats.viewCount);
			if (typeof data.challengeInfo.challenge.profileLarger === "string" && data.challengeInfo.challenge.profileLarger.length > 0) {
				console.log("cover: " + data.challengeInfo.challenge.profileLarger);
			}
			if (typeof data.challengeInfo.challenge.desc === "string" && data.challengeInfo.challenge.desc.length > 0) {
				console.log(data.challengeInfo.challenge.desc);
			}
		}
		callback(null);
	});
}
function infoVideo(id, callback) {
	requestTiktok("/api/item/detail/?itemId=" + id, function(error, data) {
		if (error !== null) {
			console.error(error);
			callback(null);
			return;
		} else if (typeof data !== "object" || data === null
		|| typeof data.itemInfo !== "object" || data.itemInfo === null
		|| typeof data.itemInfo.itemStruct !== "object" || typeof data.itemInfo.itemStruct === null
		|| typeof data.itemInfo.itemStruct.stats !== "object" || typeof data.itemInfo.itemStruct.stats === null
		|| typeof data.itemInfo.itemStruct.video !== "object" || typeof data.itemInfo.itemStruct.video === null) {
			console.error(new Error("Unexpected response."));
			callback(null);
			return;
		}
		console.log("id: " + data.itemInfo.itemStruct.id);
		console.log("created: " + createTimeToString(+data.itemInfo.itemStruct.createTime));
		console.log("views: " + data.itemInfo.itemStruct.stats.playCount);
		console.log("likes: " + data.itemInfo.itemStruct.stats.diggCount);
		console.log("comments: " + data.itemInfo.itemStruct.stats.commentCount);
		console.log("shares: " + data.itemInfo.itemStruct.stats.shareCount);
		if (typeof data.itemInfo.itemStruct.video.cover === "string" && data.itemInfo.itemStruct.video.cover.length > 0) {
			console.log("cover: " + data.itemInfo.itemStruct.video.cover);
		}
		if (typeof data.itemInfo.itemStruct.video.dynamicCover === "string" && data.itemInfo.itemStruct.video.dynamicCover.length > 0) {
			console.log("dynamic cover: " + data.itemInfo.itemStruct.video.dynamicCover);
		}
		requestAweme("/aweme/v1/aweme/detail/?aweme_id=" + data.itemInfo.itemStruct.id, function(error, data_) {
			var u;
			if (error !== null) {
				//console.error(error);
				u = null;
			} else if (typeof data_ === "object" && data_ !== null
			&& typeof data_.aweme_detail === "object" && data_.aweme_detail !== null
			&& typeof data_.aweme_detail.video === "object" && data_.aweme_detail.video !== null) {
				u = getVideoUrlList(data_.aweme_detail.video);
			} else {
				u = null;
			}
			console.log("play: " + (u !== null ? quality ? getQualityUri_(u[u.length - 1]) : u[0] : data.itemInfo.itemStruct.video.playAddr));
			if (typeof data.itemInfo.itemStruct.desc === "string" && data.itemInfo.itemStruct.desc.length > 0) {
				console.log(data.itemInfo.itemStruct.desc);
			}
			if (typeof data.itemInfo.itemStruct.music === "object" && data.itemInfo.itemStruct.music !== null) {
				console.log("music id: " + data.itemInfo.itemStruct.music.id);
				console.log("music title: " + data.itemInfo.itemStruct.music.title);
				if (typeof data.itemInfo.itemStruct.music.authorName === "string" && data.itemInfo.itemStruct.music.authorName.length > 0) {
					console.log("music author: " + data.itemInfo.itemStruct.music.authorName);
				}
				if (typeof data.itemInfo.itemStruct.music.coverLarge === "string" && data.itemInfo.itemStruct.music.coverLarge.length > 0) {
					console.log("music cover: " + data.itemInfo.itemStruct.music.coverLarge);
				}
				if (typeof data.itemInfo.itemStruct.music.playUrl === "string" && data.itemInfo.itemStruct.music.playUrl.length > 0) {
					console.log("music play: " + data.itemInfo.itemStruct.music.playUrl);
				}
			}
			if (typeof data.itemInfo.itemStruct.author === "object" && data.itemInfo.itemStruct.author !== null) {
				console.log("user id: " + data.itemInfo.itemStruct.author.id);
				console.log("user unique id: " + data.itemInfo.itemStruct.author.uniqueId);
				console.log("user secure id: " + data.itemInfo.itemStruct.author.secUid);
				console.log("user nickname: " + data.itemInfo.itemStruct.author.nickname);
				console.log("user verified: " + data.itemInfo.itemStruct.author.verified);
				console.log("user private: " + data.itemInfo.itemStruct.author.secret);
				console.log("user likes: " + data.itemInfo.itemStruct.author.openFavorite);
				if (typeof data.itemInfo.itemStruct.authorStats === "object" && data.itemInfo.itemStruct.authorStats !== null) {
					console.log("user videos: " + data.itemInfo.itemStruct.authorStats.videoCount);
					console.log("user favorites: " + data.itemInfo.itemStruct.authorStats.diggCount);
					console.log("user favorited: " + data.itemInfo.itemStruct.authorStats.heartCount);
					console.log("user followings: " + data.itemInfo.itemStruct.authorStats.followingCount);
					console.log("user followers: " + data.itemInfo.itemStruct.authorStats.followerCount);
				}
				if (typeof data.itemInfo.itemStruct.author.avatarLarger === "string" && data.itemInfo.itemStruct.author.avatarLarger.length > 0) {
					console.log("user avatar: " + data.itemInfo.itemStruct.author.avatarLarger);
				}
				if (typeof data.itemInfo.itemStruct.author.signature === "string" && data.itemInfo.itemStruct.author.signature.length > 0) {
					console.log(data.itemInfo.itemStruct.author.signature);
				}
			}
			callback(null);
		});
	});
}
function downloadUserVideos(idOrName, callback) {
	var i = 0, e = 0, y = 0, c = cursor, m = true, n, v = [], f0 = function() {
		if (running) {
			while (i < v.length && e < 10) {
				f1(v[i]);
				e++;
				i++;
			}
			if (m && e < 10) {
				m = false;
				requestTiktok("/api/item_list/"
				+ "?secUid="
				+ "&id=" + idOrName
				+ "&type=1"
				+ "&sourceType=8"
				+ "&count=30"
				+ "&minCursor=0"
				+ "&maxCursor=" + (cursor = c), f2);
				return;
			}
		}
		if (e === 0 && (!running || !m || i === v.length)) {
			console.log("cursor is " + cursor);
			callback(null);
		}
	}, f1 = function(video) {
		ensureAweme(video, function(error, exists) {
			if (error !== null) {
				console.log(video.id + " failed");
				console.error(error);
			} else if (!exists) {
				console.log(video.id + " is downloaded");
				if (logger !== null) {
					try {
						fs.writeSync(logger, video.id + " " + createTimeToLog(video.time) + " " + sanitizeLog(video.desc) + os.EOL);
					} catch (e) {}
				}
			}
			e--;
			f0();
		});
	}, f2 = function(error, data) {
		if (error !== null) {
			console.error(error);
			f0();
			return;
		} else if (typeof data !== "object" || data === null
		|| typeof data.maxCursor !== "string"
		|| typeof data.hasMore !== "boolean") {
			console.error(new Error("Unexpected response."));
			f0();
			return;
		}
		n = data.hasMore;
		c = data.maxCursor;
		if (typeof data.items === "object" && data.items !== null) {
			for (var j = 0, r = ""; j < data.items.length; j++, y++) {
				if (max) {
					if (y === limit) {
						n = false;
						break;
					}
				} else if (data.items[j].createTime < limit) {
					n = false;
					break;
				}
				if (r.length > 0) {
					r += ",";
				}
				r += data.items[j].id;
			}
			if (r.length > 0) {
				requestAweme("/aweme/v1/multi/aweme/detail/?aweme_ids=[" + r + "]", f3);
				return;
			}
		}
		m = n;
		f0();
	}, f3 = function(error, data) {
		if (error !== null) {
			console.error(error);
			f0();
			return;
		}
		m = n;
		if (typeof data === "object" && data !== null
		&& typeof data.aweme_details === "object" && data.aweme_details !== null) {
			for (var j = 0, u; j < data.aweme_details.length; j++) {
				if (typeof data.aweme_details[j].video === "object" && data.aweme_details[j].video !== null
				&& (u = getVideoUrlList(data.aweme_details[j].video)) !== null) {
					v.push({
						id: data.aweme_details[j].aweme_id,
						time: data.aweme_details[j].create_time || 0,
						desc: data.aweme_details[j].desc || "",
						uri: quality ? getQualityUri(u[u.length - 1]) : u[0]
					});
				}
			}
		}
		f0();
	};
	if (idOrName.charCodeAt(0) === 64) {
		requestTiktok_("/node/share/user/@" + encodeURI(idOrName.substring(1)) + "?user_agent=", function(error, data) {//*remove
		//requestTiktok("/api/user/detail/?uniqueId=" + encodeURIComponent(idOrName.substring(1)), function(error, data) {
			if (error !== null) {
				console.error(error);
				m = false;
			} else if (typeof data !== "object" || data === null
			|| typeof data.userInfo !== "object" || data.userInfo === null
			|| typeof data.userInfo.user !== "object" || typeof data.userInfo.user === null) {
				console.error(new Error("Unexpected response."));
				m = false;
			} else {
				idOrName = data.userInfo.user.id;
			}
			f0();
		});
	} else {
		f0();
	}
}
function downloadUserLikes(idOrName, callback) {
	var i = 0, e = 0, y = 0, c = cursor, m = true, n, v = [], f0 = function() {
		if (running) {
			while (i < v.length && e < 10) {
				f1(v[i]);
				e++;
				i++;
			}
			if (m && e < 10) {
				m = false;
				requestTiktok("/api/item_list/"
				+ "?secUid="
				+ "&id=" + idOrName
				+ "&type=2"
				+ "&sourceType=9"
				+ "&count=30"
				+ "&minCursor=0"
				+ "&maxCursor=" + (cursor = c), f2);
				return;
			}
		}
		if (e === 0 && (!running || !m || i === v.length)) {
			console.log("cursor is " + cursor);
			callback(null);
		}
	}, f1 = function(video) {
		ensureAweme(video, function(error, exists) {
			if (error !== null) {
				console.log(video.id + " failed");
				console.error(error);
			} else if (!exists) {
				console.log(video.id + " is downloaded");
				if (logger !== null) {
					try {
						fs.writeSync(logger, video.id + " " + createTimeToLog(video.time) + " " + sanitizeLog(video.desc) + os.EOL);
					} catch (e) {}
				}
			}
			e--;
			f0();
		});
	}, f2 = function(error, data) {
		if (error !== null) {
			console.error(error);
			f0();
			return;
		} else if (typeof data !== "object" || data === null
		|| typeof data.maxCursor !== "string"
		|| typeof data.hasMore !== "boolean") {
			console.error(new Error("Unexpected response."));
			f0();
			return;
		}
		n = data.hasMore;
		c = data.maxCursor;
		if (typeof data.items === "object" && data.items !== null) {
			for (var j = 0, r = ""; j < data.items.length; j++, y++) {
				if (y === limit) {
					n = false;
					break;
				} else if (r.length > 0) {
					r += ",";
				}
				r += data.items[j].id;
			}
			if (r.length > 0) {
				requestAweme("/aweme/v1/multi/aweme/detail/?aweme_ids=[" + r + "]", f3);
				return;
			}
		}
		m = n;
		f0();
	}, f3 = function(error, data) {
		if (error !== null) {
			console.error(error);
			f0();
			return;
		}
		m = n;
		if (typeof data === "object" && data !== null
		&& typeof data.aweme_details === "object" && data.aweme_details !== null) {
			for (var j = 0, u; j < data.aweme_details.length; j++) {
				if (typeof data.aweme_details[j].video === "object" && data.aweme_details[j].video !== null
				&& (u = getVideoUrlList(data.aweme_details[j].video)) !== null) {
					v.push({
						id: data.aweme_details[j].aweme_id,
						time: data.aweme_details[j].create_time || 0,
						desc: data.aweme_details[j].desc || "",
						uri: quality ? getQualityUri(u[u.length - 1]) : u[0]
					});
				}
			}
		}
		f0();
	};
	if (idOrName.charCodeAt(0) === 64) {
		requestTiktok_("/node/share/user/@" + encodeURI(idOrName.substring(1)) + "?user_agent=", function(error, data) {//*remove
		//requestTiktok("/api/user/detail/?uniqueId=" + encodeURIComponent(idOrName.substring(1)), function(error, data) {
			if (error !== null) {
				console.error(error);
				m = false;
			} else if (typeof data !== "object" || data === null
			|| typeof data.userInfo !== "object" || data.userInfo === null
			|| typeof data.userInfo.user !== "object" || typeof data.userInfo.user === null) {
				console.error(new Error("Unexpected response."));
				m = false;
			} else {
				idOrName = data.userInfo.user.id;
			}
			f0();
		});
	} else {
		f0();
	}
}
function downloadMusicVideos(id, callback) {
	var i = 0, e = 0, y = 0, c = cursor, m = true, n, v = [], f0 = function() {
		if (running) {
			while (i < v.length && e < 10) {
				f1(v[i]);
				e++;
				i++;
			}
			if (m && e < 10) {
				m = false;
				requestTiktok("/api/music/item_list/"
				+ "?musicID=" + id
				+ "&count=30"
				+ "&cursor=" + (cursor = c), f2);
				return;
			}
		}
		if (e === 0 && (!running || !m || i === v.length)) {
			console.log("cursor is " + cursor);
			callback(null);
		}
	}, f1 = function(video) {
		ensureAweme(video, function(error, exists) {
			if (error !== null) {
				console.log(video.id + " failed");
				console.error(error);
			} else if (!exists) {
				console.log(video.id + " is downloaded");
				if (logger !== null) {
					try {
						fs.writeSync(logger, video.id + " " + createTimeToLog(video.time) + " " + sanitizeLog(video.desc) + os.EOL);
					} catch (e) {}
				}
			}
			e--;
			f0();
		});
	}, f2 = function(error, data) {
		if (error !== null) {
			console.error(error);
			f0();
			return;
		} else if (typeof data !== "object" || data === null
		|| typeof data.cursor !== "string"
		|| typeof data.hasMore !== "boolean") {
			console.error(new Error("Unexpected response."));
			f0();
			return;
		}
		n = data.hasMore;
		c = data.cursor;
		if (typeof data.itemList === "object" && data.itemList !== null) {
			for (var j = 0, r = ""; j < data.itemList.length; j++, y++) {
				if (y === limit) {
					n = false;
					break;
				} else if (r.length > 0) {
					r += ",";
				}
				r += data.itemList[j].id;
			}
			if (r.length > 0) {
				requestAweme("/aweme/v1/multi/aweme/detail/?aweme_ids=[" + r + "]", f3);
				return;
			}
		}
		m = n;
		f0();
	}, f3 = function(error, data) {
		if (error !== null) {
			console.error(error);
			f0();
			return;
		}
		m = n;
		if (typeof data === "object" && data !== null
		&& typeof data.aweme_details === "object" && data.aweme_details !== null) {
			for (var j = 0, u; j < data.aweme_details.length; j++) {
				if (typeof data.aweme_details[j].video === "object" && data.aweme_details[j].video !== null
				&& (u = getVideoUrlList(data.aweme_details[j].video)) !== null) {
					v.push({
						id: data.aweme_details[j].aweme_id,
						time: data.aweme_details[j].create_time || 0,
						desc: data.aweme_details[j].desc || "",
						uri: quality ? getQualityUri(u[u.length - 1]) : u[0]
					});
				}
			}
		}
		f0();
	};
	f0();
}
function downloadHashtagVideos(idOrTag, callback) {
	var i = 0, e = 0, y = 0, c = cursor, m = true, n, v = [], f0 = function() {
		if (running) {
			while (i < v.length && e < 10) {
				f1(v[i]);
				e++;
				i++;
			}
			if (m && e < 10) {
				m = false;
				requestTiktok("/api/challenge/item_list/"
				+ "?challengeID=" + idOrTag
				+ "&count=30"
				+ "&cursor=" + (cursor = c), f2);
				return;
			}
		}
		if (e === 0 && (!running || !m || i === v.length)) {
			console.log("cursor is " + cursor);
			callback(null);
		}
	}, f1 = function(video) {
		ensureAweme(video, function(error, exists) {
			if (error !== null) {
				console.log(video.id + " failed");
				console.error(error);
			} else if (!exists) {
				console.log(video.id + " is downloaded");
				if (logger !== null) {
					try {
						fs.writeSync(logger, video.id + " " + createTimeToLog(video.time) + " " + sanitizeLog(video.desc) + os.EOL);
					} catch (e) {}
				}
			}
			e--;
			f0();
		});
	}, f2 = function(error, data) {
		if (error !== null) {
			console.error(error);
			f0();
			return;
		} else if (typeof data !== "object" || data === null
		|| typeof data.cursor !== "string"
		|| typeof data.hasMore !== "boolean") {
			console.error(new Error("Unexpected response."));
			f0();
			return;
		}
		n = data.hasMore;
		c = data.cursor;
		if (typeof data.itemList === "object" && data.itemList !== null) {
			for (var j = 0, r = ""; j < data.itemList.length; j++, y++) {
				if (y === limit) {
					n = false;
					break;
				} else if (r.length > 0) {
					r += ",";
				}
				r += data.itemList[j].id;
			}
			if (r.length > 0) {
				requestAweme("/aweme/v1/multi/aweme/detail/?aweme_ids=[" + r + "]", f3);
				return;
			}
		}
		m = n;
		f0();
	}, f3 = function(error, data) {
		if (error !== null) {
			console.error(error);
			f0();
			return;
		}
		m = n;
		if (typeof data === "object" && data !== null
		&& typeof data.aweme_details === "object" && data.aweme_details !== null) {
			for (var j = 0, u; j < data.aweme_details.length; j++) {
				if (typeof data.aweme_details[j].video === "object" && data.aweme_details[j].video !== null
				&& (u = getVideoUrlList(data.aweme_details[j].video)) !== null) {
					v.push({
						id: data.aweme_details[j].aweme_id,
						time: data.aweme_details[j].create_time || 0,
						desc: data.aweme_details[j].desc || "",
						uri: quality ? getQualityUri(u[u.length - 1]) : u[0]
					});
				}
			}
		}
		f0();
	};
	if (idOrTag.charCodeAt(0) === 35) {
		requestTiktok("/api/challenge/detail/?challengeName=" + encodeURIComponent(idOrTag.substring(1)), function(error, data) {
			if (error !== null) {
				console.error(error);
				m = false;
			} else if (typeof data !== "object" || data === null
			|| typeof data.challengeInfo !== "object" || data.challengeInfo === null
			|| typeof data.challengeInfo.challenge !== "object" || typeof data.challengeInfo.challenge === null) {
				console.error(new Error("Unexpected response."));
				m = false;
			} else {
				idOrTag = data.challengeInfo.challenge.id;
			}
			f0();
		});
	} else {
		f0();
	}
}
function downloadVideos(ids, callback) {
	var i = 0, e = 0, c = 0, m = true, v = [], f0 = function() {
		if (running) {
			while (i < v.length && e < 10) {
				f1(v[i]);
				e++;
				i++;
			}
			if (m && e < 10) {
				m = false;
				requestAweme("/aweme/v1/multi/aweme/detail/?aweme_ids=[" + ids.slice(c, c + 30).join() + "]", f2);//+ "origin_type="//+ "push_params="
				return;
			}
		}
		if (e === 0 && (!running || !m || i === v.length)) {
			callback(null);
		}
	}, f1 = function(video) {
		ensureAweme(video, function(error, exists) {
			if (error !== null) {
				console.log(video.id + " failed");
				console.error(error);
			} else if (!exists) {
				console.log(video.id + " is downloaded");
				if (logger !== null) {
					try {
						fs.writeSync(logger, video.id + " " + createTimeToLog(video.time) + " " + sanitizeLog(video.desc) + os.EOL);
					} catch (e) {}
				}
			}
			e--;
			f0();
		});
	}, f2 = function(error, data) {
		if (error !== null) {
			console.error(error);
			f0();
			return;
		}
		c += 30;
		m = c < ids.length;
		if (typeof data === "object" && data !== null
		&& typeof data.aweme_details === "object" && data.aweme_details !== null) {
			for (var j = 0, u; j < data.aweme_details.length; j++) {
				if (v.length === limit) {
					m = false;
					break;
				} else if (typeof data.aweme_details[j].video === "object" && data.aweme_details[j].video !== null
				&& (u = getVideoUrlList(data.aweme_details[j].video)) !== null) {
					v.push({
						id: data.aweme_details[j].aweme_id,
						time: data.aweme_details[j].create_time || 0,
						desc: data.aweme_details[j].desc || "",
						uri: quality ? getQualityUri(u[u.length - 1]) : u[0]
					});
				}
			}
		}
		f0();
	};
	f0();
}
function execCmds(commands, repeat, processes, output, callback) {
	var i = 0, e = 0, f0 = function() {
		timeout = null;
		if (running) {
			while (i < commands.length && e < processes) {
				f1(i);
				i++;
				e++;
			}
			if (e === 0 && i === commands.length && repeat > -1) {
				i = 0;
				timeout = setTimeout(f0, repeat);
				return;
			}
		}
		if (e === 0 && (!running || i === commands.length)) {
			callback(null);
		}
	}, f1 = function(index) {
		var a, p;
		try {
			a = splitCmd(commands[index], [__filename]);
		} catch (e_) {
			console.log(index + " 0 " + commands[index]);
			console.error(e_);
			process.nextTick(f2, null, null);
			return;
		}
		p = child_process.spawn("node", a, {stdio: output ? ["ignore", "pipe", "pipe"] : "ignore"});
		p.on("exit", f2);
		if (output) {
			p.stdout.pipe(process.stdout);
			p.stderr.pipe(process.stderr);
		}
		//p["x-index"] = i;
		console.log(index + " " + p.pid + " " + commands[index]);
	}, f2 = function(code, signal) {
		//console.log(this["x-index"] + " " + this.pid + " " + commands[this["x-index"]]);
		e--;
		f0();
	};
	f0();
}
process.on("exit", function() {
	if (logger !== null) {
		try {
			fs.closeSync(logger);
		} catch (e) {}
	}
});
process.on("SIGINT", function() {
	running = false;
	if (timeout !== null) {
		clearTimeout(timeout);
		timeout = null;
	}
});
(function() {
	var i, t, a = parseArgv(process.argv), f;
	if (a.e !== undefined) {
		f = function(error, data) {
			if (error !== null) {
				console.error(error);
				return;
			}
			execCmds(getCmds(data),
			a.r !== undefined && !isNaN(i = parseInt(a.r, 10)) && i > -1 ? i * 1000 : -1,
			a.p !== undefined && !isNaN(i = parseInt(a.p, 10)) && i > 1 ? i : 1,
			a.o !== undefined, emptyFunction);
		};
		if (a.e.length === 0) {
			readStdIn(f);
		} else {
			fs.readFile(path.isAbsolute(a.e) ? a.e : __dirname + path.sep + a.e, "utf8", f);
		}
		return;
	} else if (a.t === undefined || a.i === undefined) {
		console.log(help);
		return;
	} else if (a.f !== undefined) {
		directory = path.isAbsolute(a.f) ? a.f : __dirname + path.sep + a.f;
	}
	try {
		ensureDirectorySync(directory);
		process.chdir(directory);
	} catch (e) {
		console.error(e);
		return;
	}
	t = ({
		"ui": 0,
		"mi": 1,
		"hi": 2,
		"vi": 3,
		"uv": 4,
		"ul": 5,
		"mv": 6,
		"hv": 7,
		"v": 8
	})[a.t.toLowerCase()];
	if (a.j !== undefined) {
		cookie = a.j;
	}
	if (a.l !== undefined) {
		if (t === 4 && a.l.length === 10 && !isNaN(i = Math.floor((new Date(a.l + "T00:00:00.000Z")).getTime() / 1000))) {
			limit = i;
			max = false;
		} else if (a.l.length > 0 && !isNaN(i = parseInt(a.l, 10))) {
			limit = i;
			max = true;
		}
	}
	date = a.c !== undefined;
	description = a.d !== undefined;
	quality = a.q !== undefined;
	hevc = a.h !== undefined;
	if (a.g !== undefined) {
		try {
			logger = fs.openSync("log.txt", "a");
		} catch (e) {
			console.error(e);
			return;
		}
	}
	switch (t) {
		case 0:
			if (a.i.length === 0) {
				break;
			} else if (a.i.charCodeAt(0) === 64) {
				if (a.i.length === 1) {
					console.error(new Error("Name is empty."));
					return;
				}
			} else if (!idRegex.test(a.i)) {
				console.error(new Error("Id is not valid."));
				return;
			}
			deferOpenBrowser().then(function(value) {
				infoUser(a.i, deferCloseBrowser);
			}).catch(function(error) {
				console.error(error);
				deferCloseBrowser();
			});
			return;
		case 1:
			if (a.i.length === 0) {
				break;
			} else if (!idRegex.test(a.i)) {
				console.error(new Error("Id is not valid."));
				return;
			}
			deferOpenBrowser().then(function(value) {
				infoMusic(a.i, deferCloseBrowser);
			}).catch(function(error) {
				console.error(error);
				deferCloseBrowser();
			});
			return;
		case 2:
			if (a.i.length === 0) {
				break;
			} else if (a.i.charCodeAt(0) === 35) {
				if (a.i.length === 1) {
					console.error(new Error("Tag is empty."));
					return;
				}
			} else if (!idRegex.test(a.i)) {
				console.error(new Error("Id is not valid."));
				return;
			}
			deferOpenBrowser().then(function(value) {
				infoHashtag(a.i, deferCloseBrowser);
			}).catch(function(error) {
				console.error(error);
				deferCloseBrowser();
			});
			return;
		case 3:
			if (a.i.length === 0) {
				break;
			} else if (!idRegex.test(a.i)) {
				console.error(new Error("Id is not valid."));
				return;
			}
			deferOpenBrowser().then(function(value) {
				infoVideo(a.i, deferCloseBrowser);
			}).catch(function(error) {
				console.error(error);
				deferCloseBrowser();
			});
			return;
		case 4:
			if (a.i.length === 0) {
				break;
			} else if (a.i.charCodeAt(0) === 64) {
				if (a.i.length === 1) {
					console.error(new Error("Name is empty."));
					return;
				}
			} else if (!idRegex.test(a.i)) {
				console.error(new Error("Id is not valid."));
				return;
			}
			if (a.o !== undefined && !isNaN(i = parseInt(a.o, 10))) {
				cursor = i;
			}
			deferOpenBrowser().then(function(value) {
				downloadUserVideos(a.i, deferCloseBrowser);
			}).catch(function(error) {
				console.error(error);
				deferCloseBrowser();
			});
			return;
		case 5:
			if (a.i.length === 0) {
				break;
			} else if (a.i.charCodeAt(0) === 64) {
				if (a.i.length === 1) {
					console.error(new Error("Name is empty."));
					return;
				}
			} else if (!idRegex.test(a.i)) {
				console.error(new Error("Id is not valid."));
				return;
			}
			if (a.o !== undefined && !isNaN(i = parseInt(a.o, 10))) {
				cursor = i;
			}
			deferOpenBrowser().then(function(value) {
				downloadUserLikes(a.i, deferCloseBrowser);
			}).catch(function(error) {
				console.error(error);
				deferCloseBrowser();
			});
			return;
		case 6:
			if (a.i.length === 0) {
				break;
			} else if (!idRegex.test(a.i)) {
				console.error(new Error("Id is not valid."));
				return;
			}
			if (a.o !== undefined && !isNaN(i = parseInt(a.o, 10))) {
				cursor = i;
			}
			deferOpenBrowser().then(function(value) {
				downloadMusicVideos(a.i, deferCloseBrowser);
			}).catch(function(error) {
				console.error(error);
				deferCloseBrowser();
			});
			return;
		case 7:
			if (a.i.length === 0) {
				break;
			} else if (a.i.charCodeAt(0) === 35) {
				if (a.i.length === 1) {
					console.error(new Error("Tag is empty."));
					return;
				}
			} else if (!idRegex.test(a.i)) {
				console.error(new Error("Id is not valid."));
				return;
			}
			if (a.o !== undefined && !isNaN(i = parseInt(a.o, 10))) {
				cursor = i;
			}
			deferOpenBrowser().then(function(value) {
				downloadHashtagVideos(a.i, deferCloseBrowser);
			}).catch(function(error) {
				console.error(error);
				deferCloseBrowser();
			});
			return;
		case 8:
			if (idRegex.test(a.i)) {
				downloadVideos([a.i], emptyFunction);
			} else {
				f = function(error, data) {
					if (error !== null) {
						console.error(error);
						return;
					}
					getIds(data, function(error, ids) {
						if (error !== null) {
							console.error(error);
						} else if (ids.length > 0) {
							downloadVideos(ids, emptyFunction);
						}
					});
				};
				if (a.i.length === 0) {
					readStdIn(f);
				} else {
					fs.readFile(path.isAbsolute(a.i) ? a.i : __dirname + path.sep + a.i, "utf8", f);
				}
			}
			return;
	}
	console.log(help);
})();