'use strict';
const path = require('path');
const execa = require('execa');
const arch = require('arch');

const windowBinaryPath = path.join(__dirname, '../fallbacks/windows');

// Binaries from: https://github.com/sindresorhus/win-clipboard
const windowBinaryCopy = arch() === 'x64' ?
	path.join(windowBinaryPath, 'clipboard_x86_64.exe') :
	path.join(windowBinaryPath, 'clipboard_i686.exe');

// Compiled from clipboard_paste_*.ahk
const windowBinaryPaste = arch() === 'x64' ?
	path.join(windowBinaryPath, 'clipboard_paste_x86_64.exe') :
	path.join(windowBinaryPath, 'clipboard_paste_i686.exe');

module.exports = {
	copy: async options => execa(windowBinaryCopy, ['--copy'], options),
//	paste: async options => execa.stdout(windowBinaryCopy, ['--paste'], options),
	paste: async options => execa.stdout(windowBinaryPaste, options),
	copySync: options => execa.sync(windowBinaryCopy, ['--copy'], options),
//	pasteSync: options => execa.sync(windowBinaryCopy, ['--paste'], options)
	pasteSync: options => execa.sync(windowBinaryPaste, options)
};
